/* Implement Input/Output runtime actions for CHILL.
   Copyright (C) 1992,1993 Free Software Foundation, Inc.
   Author: Wilfried Moser, et al

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#define __CHILL_LIB__

#define DEBUG

#include <stdio.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <errno.h>
#include <limits.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#ifdef sun	/* FIXME */
#include <floatingpoint.h>
#endif
#ifndef VMS
#include <unistd.h>
#endif

#include "iomodes.h"
#include "fileio.h"

/*
 * function __write_buffer
 *
 * parameters:
 *  fst_index		index of file system table
 *
 * returns:
 *  int			0 ... success, 1 ... fail
 *
 * abstract:
 *  First the file is positioned at ABS_FILE_POS. Then all changed blocks
 *  of the file_buffer (indicated by a one in the according bit in the
 *  BIT_LIST) are written to the file. The management values in the
 *  file_system_table are updated.
 *
*/

int
__write_buffer (int fst_index)
{
    return (0);
} /* __write_buffer */


/*
 * function __read_buffer
 *
 * parameters:
 *  fst_index		index into file system table
 *  position		new position of the physical file pointer of this file. The
 *			`file buffer window' starts from this position in the file.
 *
 * returns:
 *  int			0 ... success, 1 ... fail
 *
 * abstract:
 *  The physical file pointer is moved to the position `position'. This
 *  value is saved in ABS_FILE_POS und the file buffer is filled with
 *  NUMBER_BUFFER_BYTES starting from this position. After the read action
 *  some values in the file_system_table are updated.
 *
*/

int
__read_buffer (short fst_index, int position)
{
    return (0);
} /* __read_buffer */


/*
 * function __check_buffer
 *
 * !!!!! must be added !!!!
*/

int
__check_buffer (short fst_index, int position, int move_mod_512)
{
    return (0);
} /* __check_buffer */
