/* Implement POWERSET runtime actions for CHILL.
   Copyright (C) 1992,1993 Free Software Foundation, Inc.
   Author: Wilfried Moser, et al

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#define __CHILL_LIB__

#include "config.h"
#include <stdio.h>
#include "powerset.h"

/*
 * Store a set's bit number in the appropriate
 * size output variable.
 * This would be better as a function, but the way we
 * build the library makes that hard.
 */
void
__store_out (out,outlen,value)    
     char          *out;
     unsigned long  outlen;
     unsigned long  value;
{                                 
  if (outlen == sizeof (char))       
    *out = (char)value;              
  else if (outlen == sizeof (short)) 
    *(short *)out = (short)value;    
  else if (outlen == sizeof (long))  
    *(long *)out = (long)value;      
  else                               
    *(int *)out = (int)value;        
}
