testvars: module
grant all;
dcl bool_true BOOL := TRUE;
dcl bool_false BOOL := FALSE;
dcl booltable1 array (0:3) BOOL init := [ TRUE, FALSE, FALSE, TRUE ];
dcl booltable2 array (4:7) BOOL init := [ TRUE, FALSE, FALSE, TRUE ];

dcl control_char CHAR := C'07';
dcl printable_char CHAR := 'a';
dcl chartable1 array (0:2) CHAR init := [ C'00', C'01', C'02' ];
dcl chartable2 array (3:5) CHAR init := [ C'00', C'01', C'02' ];

dcl string1 char (4) := 'abcd';
dcl string2 char (5) := 'ef' // C'00' // 'gh';
dcl string3 char (6) := 'ef' // 'gh' // 'ij';
dcl string4 char (7) := (6) 'z' // C'00';

dcl byte_low BYTE := -128;
dcl byte_high BYTE := 127;
dcl bytetable1 array (0:4) BYTE init := [ -2, -1, 0, 1, 2 ];
dcl bytetable2 array (5:9) BYTE init := [ -2, -1, 0, 1, 2 ];
dcl bytetable3 array (1:2,'c':'d',FALSE:TRUE) BYTE
	init := [ [ [ 0, 1 ], [ 2, 3 ] ], [ [ 4, 5 ], [ 6, 7 ] ] ];
dcl bytetable4 array (1:2) array ('c':'d') array (FALSE:TRUE) BYTE
	init := [ [ [ 0, 1 ], [ 2, 3 ] ], [ [ 4, 5 ], [ 6, 7 ] ] ];

dcl ubyte_low UBYTE := 0;
dcl ubyte_high UBYTE := 255;
dcl ubytetable1 array (0:4) UBYTE init := [ 0, 1, 2, 3, 4 ];
dcl ubytetable2 array (5:9) UBYTE init := [ 0, 1, 2, 3, 4 ];

dcl int_low INT := -32_768;
dcl int_high INT := 32_767;
dcl inttable1 array (0:4) INT init := [ -2, -1, 0, 1, 2 ];
dcl inttable2 array (5:9) INT init := [ -2, -1, 0, 1, 2 ];

dcl uint_low UINT := 0;
dcl uint_high UINT := 65_535;
dcl uinttable1 array (0:4) UINT init := [ 0, 1, 2, 3, 4 ];
dcl uinttable2 array (5:9) UINT init := [ 0, 1, 2, 3, 4 ];

dcl long_low LONG := -2_147_483_648;
dcl long_high LONG := 2_147_483_647;
dcl longtable1 array (0:4) LONG init := [ -2, -1, 0, 1, 2 ];
dcl longtable2 array (5:9) LONG init := [ -2, -1, 0, 1, 2 ];

dcl ulong_low ULONG := 0;
dcl ulong_high ULONG := 4_294_967_295;
dcl ulongtable1 array (0:4) ULONG init := [ 0, 1, 2, 3, 4 ];
dcl ulongtable2 array (5:9) ULONG init := [ 0, 1, 2, 3, 4 ];

dcl real1 REAL := 3.14159265358;
dcl real2 REAL := -3.14159265358;
dcl realtable1 array (0:4) REAL init := [ -2.0, -1.0, 0.0, 1.0, 2.0 ];
dcl realtable2 array (5:9) REAL init := [ -2.0, -1.0, 0.0, 1.0, 2.0 ];

dcl long_real1 LONG_REAL := 3.14e300;
dcl long_real2 LONG_REAL := -3.14e-300;
dcl longrealtable1 array (0:4) LONG_REAL init := [ -2.0, -1.0, 0.0, 1.0, 2.0 ];
dcl longrealtable2 array (5:9) LONG_REAL init := [ -2.0, -1.0, 0.0, 1.0, 2.0 ];

dcl powerset1 POWERSET INT(0:7);
/* dcl chars1 CHAR (16) init := (16)'b'; */
dcl bits1 BIT(20) := B'11111111000010101011';

NEWMODE simple_struct = STRUCT (abool BOOL, aint INT, astring CHAR (8));
dcl struct1 simple_struct := [ TRUE, 123, "a string" ];

NEWMODE nested_struct = STRUCT (abool BOOL, nstruct simple_struct, aint INT);
dcl struct2 nested_struct := [ TRUE, [ FALSE, 456, "deadbeef" ], 789 ];

/* This table is used as a source for every ascii character. */

dcl asciitable array (0:255) CHAR init := [
    C'00', C'01', C'02', C'03', C'04', C'05', C'06', C'07',
    C'08', C'09', C'0a', C'0b', C'0c', C'0d', C'0e', C'0f',
    C'10', C'11', C'12', C'13', C'14', C'15', C'16', C'17',
    C'18', C'19', C'1a', C'1b', C'1c', C'1d', C'1e', C'1f',
    C'20', C'21', C'22', C'23', C'24', C'25', C'26', C'27',
    C'28', C'29', C'2a', C'2b', C'2c', C'2d', C'2e', C'2f',
    C'30', C'31', C'32', C'33', C'34', C'35', C'36', C'37',
    C'38', C'39', C'3a', C'3b', C'3c', C'3d', C'3e', C'3f',
    C'40', C'41', C'42', C'43', C'44', C'45', C'46', C'47',
    C'48', C'49', C'4a', C'4b', C'4c', C'4d', C'4e', C'4f',
    C'50', C'51', C'52', C'53', C'54', C'55', C'56', C'57',
    C'58', C'59', C'5a', C'5b', C'5c', C'5d', C'5e', C'5f',
    C'60', C'61', C'62', C'63', C'64', C'65', C'66', C'67',
    C'68', C'69', C'6a', C'6b', C'6c', C'6d', C'6e', C'6f',
    C'70', C'71', C'72', C'73', C'74', C'75', C'76', C'77',
    C'78', C'79', C'7a', C'7b', C'7c', C'7d', C'7e', C'7f',
    C'80', C'81', C'82', C'83', C'84', C'85', C'86', C'87',
    C'88', C'89', C'8a', C'8b', C'8c', C'8d', C'8e', C'8f',
    C'90', C'91', C'92', C'93', C'94', C'95', C'96', C'97',
    C'98', C'99', C'9a', C'9b', C'9c', C'9d', C'9e', C'9f',
    C'a0', C'a1', C'a2', C'a3', C'a4', C'a5', C'a6', C'a7',
    C'a8', C'a9', C'aa', C'ab', C'ac', C'ad', C'ae', C'af',
    C'b0', C'b1', C'b2', C'b3', C'b4', C'b5', C'b6', C'b7',
    C'b8', C'b9', C'ba', C'bb', C'bc', C'bd', C'be', C'bf',
    C'c0', C'c1', C'c2', C'c3', C'c4', C'c5', C'c6', C'c7',
    C'c8', C'c9', C'ca', C'cb', C'cc', C'cd', C'ce', C'cf',
    C'd0', C'd1', C'd2', C'd3', C'd4', C'd5', C'd6', C'd7',
    C'd8', C'd9', C'da', C'db', C'dc', C'dd', C'de', C'df',
    C'e0', C'e1', C'e2', C'e3', C'e4', C'e5', C'e6', C'e7',
    C'e8', C'e9', C'ea', C'eb', C'ec', C'ed', C'ee', C'ef',
    C'f0', C'f1', C'f2', C'f3', C'f4', C'f5', C'f6', C'f7',
    C'f8', C'f9', C'fa', C'fb', C'fc', C'fd', C'fe', C'ff'
];

dcl charmatrix array (0:255) CHAR init := [
  'a','X','X','X','X','X','X','X','X','X','X','X','X','X','X','X',
  'a','a','X','X','X','X','X','X','X','X','X','X','X','X','X','X',
  'a','a','a','X','X','X','X','X','X','X','X','X','X','X','X','X',
  'a','a','a','a','X','X','X','X','X','X','X','X','X','X','X','X',
  'a','a','a','a','a','X','X','X','X','X','X','X','X','X','X','X',
  'a','a','a','a','a','a','X','X','X','X','X','X','X','X','X','X',
  'a','a','a','a','a','a','a','X','X','X','X','X','X','X','X','X',
  'a','a','a','a','a','a','a','a','X','X','X','X','X','X','X','X',
  'a','a','a','a','a','a','a','a','a','X','X','X','X','X','X','X',
  'a','a','a','a','a','a','a','a','a','a','X','X','X','X','X','X',
  'a','a','a','a','a','a','a','a','a','a','a','X','X','X','X','X',
  'a','a','a','a','a','a','a','a','a','a','a','a','X','X','X','X',
  'a','a','a','a','a','a','a','a','a','a','a','a','a','X','X','X',
  'a','a','a','a','a','a','a','a','a','a','a','a','a','a','X','X',
  'a','a','a','a','a','a','a','a','a','a','a','a','a','a','a','X',
  'a','a','a','a','a','a','a','a','a','a','a','a','a','a','a','a'
];

booleans: proc ();

	dcl val1 BOOL := TRUE;
	dcl val2 BOOL := FALSE;
	dcl val3 BOOL := TRUE;

	val1 := TRUE XOR TRUE;
	val1 := TRUE XOR FALSE;
	val1 := FALSE XOR TRUE;
	val1 := FALSE XOR FALSE;
	val1 := val2 XOR val3;

	val1 := TRUE AND TRUE;
	val1 := TRUE AND FALSE;
	val1 := FALSE AND TRUE;
	val1 := FALSE AND FALSE;
	val1 := val2 AND val3;

	val1 := TRUE ANDIF TRUE;
	val1 := TRUE ANDIF FALSE;
	val1 := FALSE ANDIF TRUE;
	val1 := FALSE ANDIF FALSE;
	val1 := val2 ANDIF val3;

	val1 := TRUE OR TRUE;
	val1 := TRUE OR FALSE;
	val1 := FALSE OR TRUE;
	val1 := FALSE OR FALSE;
	val1 := val2 OR val3;

	val1 := NOT TRUE;
	val1 := NOT FALSE;
	val1 := NOT val2;
	val1 := NOT val3;
	
end booleans;

scalar_arithmetic: proc ();

	dcl val1 INT := 1;
	dcl val2 INT := 2;
	dcl val3 INT := 3;

	val1 := -val2;
	val1 := val2 + val3;
	val1 := val2 - val3;
	val1 := val2 * val3;
	val1 := val2 / val3;
	val1 := val2 MOD val3;
	val1 := val2 REM val3;
	
end scalar_arithmetic;

write_arrays: proc ();

	inttable1(0) := 0;
	inttable1(1) := 1;
	inttable1(2) := 2;
	inttable1(3) := 3;
	inttable1(4) := 4;
	inttable2(5) := 5;
	inttable2(6) := 6;
	inttable2(7) := 7;
	inttable2(8) := 8;
	inttable2(9) := 9;

end write_arrays;

uint_low := 0;

scalar_arithmetic ();
write_arrays ();
booleans ();

end;
