/* CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

absolute_timing_action: MODULE

DCL abs_time, now, tmp_time TIME;
DCL i LONG;

NEWMODE time_string = CHARS(30) VARYING;

DCL disp_sec, disp_min, disp_hour, disp_day, disp_month, disp_year LONG;
DCL display_base TIME;

print_time: PROC (t TIME) RETURNS (time_string);

  DCL months ARRAY (1:12) CHARS(3) STATIC :=
      [ "Jan", "Feb", "Mar", "Apr", "May", "Jun",
        "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" ];
  DCL year LONG;
  DCL mon, day BYTE;
  DCL hour, min, sec INT;
  DCL str time_string;

  INTTIME (t, year, mon, day, hour, min, sec);
  WRITETEXT (str, """%C2 %C %C, %C2P0:%C2P0:%C2P0""",
	     day, months(mon), year, hour, min, sec);
  RETURN str;
END print_time;

x: PROCESS ();
  DCL sec, min, hour LONG;

  now := ABSTIME ();
  DO FOR i := 1 to 5;
    INTTIME (ABSTIME (), hour, min, sec);
    sec +:= 2;
    disp_sec +:= 2;

--
-- this will fail after 23:59:59
--
    IF sec >= 60 THEN
      sec -:= 60;
      min +:= 1;
    FI;
    IF min >= 60 THEN
      min -:= 60;
      hour +:= 1;
    FI;
    IF i = 5 THEN
      abs_time := now;
    ELSE
      abs_time := ABSTIME (hour, min, sec);
    FI;

l1:
    AT abs_time IN
      tmp_time := ABSTIME (disp_year, disp_month, disp_day,
                           disp_hour, disp_min, disp_sec);
      WRITETEXT (stdout, "It should be %C.%/",
	         print_time (tmp_time));
    TIMEOUT
      WRITETEXT (stdout, "Timerfail for %C%/", print_time (display_base));
      EXIT l1;
      WRITETEXT (stdout, "EXIT from AT doesn't work.%/");
    END;
  OD;
END x;

disp_sec := 15;
disp_min := 13;
disp_hour := 10;
disp_month := 12;
disp_day := 11;
disp_year := 1956;
display_base := ABSTIME (disp_year, disp_month, disp_day,
			 disp_hour, disp_min, disp_sec);
WRITETEXT (stdout, "This example will virtually start at %C%/",
	   print_time (display_base));
WRITETEXT (stdout, "  It will run approx. 8 secs.%/%/");

START x (-1);

END absolute_timing_action;