/* GNU CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

concat: MODULE

  <> use_seize_file 'chprintf.grt' <>
  SEIZE chprintf;

DCL a1 CHARS(3) := "123",
    a2 CHARS(3) := "qwe",
    a3 CHARS(4) := "_-=#",
    a4 CHARS(10) := "          ";

DCL v1 CHARS(3)  VARYING := "321",
    v2 CHARS(3)  VARYING := "ewq",
    v3 CHARS(4)  VARYING := "#=-_", 
    v4 CHARS(10) VARYING := "          ";

show_str:
PROC (str CHAR(30) VARYING);
  DCL i INT,
      j CHAR;
 
  chprintf (" = """, 0);
  DO FOR i := 0 TO LENGTH (str) - 1;
    j := str(i);
    chprintf ("%c", LONG (j));
  OD;
  chprintf ("""^J", 0);
END show_str;

a4 := a1 // a2 // a3;
chprintf ("a1 // a2 // a3", 0);
show_str (a4);

a4 := a1 // "const12";
chprintf ("a1 // const12", 0);
show_str (a4);

a4 := v1 // a2 // a3;
chprintf ("v1 // a2 // a3", 0);
show_str (a4);

a4 := v1 // "const12";
chprintf ("v1 // const12", 0);
show_str (a4);

a4 := a1 // v2 // a3;
chprintf ("a1 // v2 // a3", 0);
show_str (a4);

a4 := "const12" // v2;
chprintf ("const12 // v2", 0);
show_str (a4);

a4 := v1 // v2 // v3;
chprintf ("v1 // v2 // v3", 0);
show_str (a4);

v4 := a1 // a2 // a3;
chprintf ("a1 // a2 // a3", 0);
show_str (v4);

v4 := a1 // "const12";
chprintf ("a1 // const12", 0);
show_str (v4);

v4 := v1 // a2 // a3;
chprintf ("v1 // a2 // a3", 0);
show_str (v4);

v4 := v1 // "const12";
chprintf ("v1 // const12", 0);
show_str (v4);

v4 := a1 // v2 // a3;
chprintf ("a1 // v2 // a3", 0);
show_str (v4);

v4 := "const12" // v2;
chprintf ("const12 // v2", 0);
show_str (v4);

v4 := v1 // v2 // v3;
chprintf ("v1 // v2 // v3", 0);
show_str (v4);

v4 := "abc" // "def" // "4321";
chprintf ("abc // def // 4321", 0);
show_str (v4);

END concat;
