/* GNU CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

doloc: MODULE 

  <> USE_SEIZE_FILE 'chprintf.grt' <>
  SEIZE chprintf;

NEWMODE foo = STRUCT (i INT, b BOOL); 

DCL bar ARRAY (1:4) foo; 
DCL x, y foo;

DCL cstr CHAR(30) := "abcdefghijklmnopqrstuvwxyz1234";
DCL vstr CHAR(10) VARYING := "aZ";
DCL c, c1 CHAR;
DCL i INT;

func1: PROC ();
   DCL cc  CHAR LOC := cstr(20); 
   DCL cc1 CHAR LOC := cstr(19);
   DCL vc  CHAR LOC := vstr(2); 
   DCL vc1 CHAR LOC := vstr(2);
   DCL i1 CHAR := 'a';
   DCL i2 CHAR := 'A';

   i := 10;
   DO FOR x IN bar; 
      x.i := i;
      x.b := false; 
      i + := 1;
   OD;

   chprintf ("bar(1).i = %d^J", bar(1).i);
   chprintf ("bar(1).b = %d^J", LONG(bar(1).b));
   chprintf ("bar(2).i = %d^J", bar(2).i);
   chprintf ("bar(2).b = %d^J", LONG(bar(2).b));
   chprintf ("bar(3).i = %d^J", bar(3).i);
   chprintf ("bar(3).b = %d^J", LONG(bar(3).b));
   chprintf ("bar(4).i = %d^J", bar(4).i);
   chprintf ("bar(4).b = %d^J", LONG(bar(4).b));

   DO FOR y DOWN IN bar;
      y.i := i - 10; 
      y.b := TRUE;
      i + := 1;
   OD;

   chprintf ("bar(4).i = %d^J", bar(4).i);
   chprintf ("bar(4).b = %d^J", LONG(bar(4).b));
   chprintf ("bar(3).i = %d^J", bar(3).i);
   chprintf ("bar(3).b = %d^J", LONG(bar(3).b));
   chprintf ("bar(2).i = %d^J", bar(2).i);
   chprintf ("bar(2).b = %d^J", LONG(bar(2).b));
   chprintf ("bar(1).i = %d^J", bar(1).i);
   chprintf ("bar(1).b = %d^J", LONG(bar(1).b));

   -- this shouldn't change bar at all - should exit 
   -- from top of loop
   DO FOR x IN bar WHILE i1 <= i2; 
      x.i := 10;
      x.b := FALSE; 
   OD;

   chprintf ("bar(1).i = %d^J", bar(1).i);
   chprintf ("bar(1).b = %d^J", LONG(bar(1).b));
   chprintf ("bar(2).i = %d^J", bar(2).i);
   chprintf ("bar(2).b = %d^J", LONG(bar(2).b));
   chprintf ("bar(3).i = %d^J", bar(3).i);
   chprintf ("bar(3).b = %d^J", LONG(bar(3).b));
   chprintf ("bar(4).i = %d^J", bar(4).i);
   chprintf ("bar(4).b = %d^J", LONG(bar(4).b));

   DO FOR cc IN cstr; 
      cc := i1; 
      i1 := SUCC (i1);
      chprintf ("up i1 = %d^J", LONG(i1));
   OD;

   DO FOR cc1 DOWN IN cstr; 
      cc1 := i2;
      i2 := PRED (i2);
      chprintf ("down i2 = %d^J", LONG(i2));
   OD;

   DO FOR vc IN vstr; 
      chprintf ("vc in vstr test: `%c'^J", LONG(vc));
   OD;

   DO FOR vc1 DOWN IN vstr; 
      chprintf ("vc1 in vstr test: `%c'^J", LONG(vc1));
   OD;
END func1; 

  func1();

END doloc;
