/* GNU CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

dowith: MODULE

  <> use_seize_file 'chprintf.grt' <>
  seize chprintf;

/* field-names at global scope. body of WITH must NOT
   refer to these locations... */
DCL free  BOOL := FALSE,
    count INT := 1,
    name  CHAR(10) := "fred rice ";--['f', 'r', 'e', 'd', ' ', 'r', 'i', 'c', 'e', ' '];
DCL b  BOOL := FALSE,
    i INT := 1,
    c  CHAR(10) := "fred rice ";--['f', 'r', 'e', 'd', ' ', 'r', 'i', 'c', 'e', ' '];
DCL j INT;

NEWMODE rec_type = STRUCT (
  free  BOOL,
  count INT,
  name  CHAR(10)
);

DCL rbuf rec_type := [ TRUE, 123, "wm. bonney" ];

chprintf ("rbuf.free  = %d^J", long(rbuf.free));          -- without the WITH
chprintf ("rbuf.count = %d^J", rbuf.count);
chprintf ("rbuf.name = ", 0);
DO FOR j := 0 TO 9;
  chprintf ("%c",  long(name(j)));
OD;
chprintf ("^J", 0);

DO WITH rbuf;
  chprintf ("free = %d^J",  long(free));              -- shorthand on RHS
  chprintf ("count = %d^J", count);
  chprintf ("name = ", 0);
  DO FOR j := 0 TO 9;
    chprintf ("%c",  long(name(j)));
  OD;
  chprintf ("^J", 0);
OD;

DO WITH rbuf;
  free := b;              -- shorthand on LHS
  count := i;
  name := c;
  chprintf ("free = %d^J",  long(free));              -- shorthand on RHS
  chprintf ("count = %d^J", count);
  chprintf ("name = ", 0);
  DO FOR j := 0 TO 9;
    chprintf ("%c",  long(name(j)));
  OD;
  chprintf ("^J", 0);
OD;

END dowith;
