/* GNU CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

dowith2: MODULE

  <> USE_SEIZE_FILE 'chprintf.grt' <>
  SEIZE chprintf;

SYNMODE stryng  = STRUCT (
		    chr CHARS (20),
		    len INT
		    );

DCL str1 stryng := [ "abc boating         ",        11 ], 
    str2 stryng := [ "sincerely yours     ",    15 ],
    str3 stryng := [ "chromodynamics      ",     14 ],
    str4 stryng := [ "transubstantiation  ", 18 ];

DCL argv ARRAY (0:3) stryng := [ str1, str2,
				 str3, str4 ];
DCL i INT := 1;

-- Demonstrate that WITH expression is only evaluated once.
DO WITH argv(i);
  chprintf ("1st char = `%c'^J", LONG (chr(0)));
  i := 1;
  chprintf ("2nd char = `%c'^J", LONG (chr(1)));
  i := 2;
  chprintf ("3rd char = `%c'^J", LONG (chr(2)));
  i := 3;
  chprintf ("length   = %d^J", LONG (len));
OD;

END dowith2;
