/* GNU CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */
-- A simple test for exception raising and handling.

except1: module

  <> use_seize_file 'chprintf.grt' <>
  seize chprintf;

--dcl foo int;

do_cause_EX2: proc () exceptions (EX2);
  cause EX2;
end do_cause_EX2;

do_cause_EX1or2: proc (which int) exceptions (EX1, EX2);
  if which = 2
  then
    do_cause_EX2();
  else
    cause EX1;
  fi;
end do_cause_EX1or2;

-- NOTE: the 'dummy' handlers listed below are needed until
-- we can work around a parser ambiguity.
test: proc (which int(0:3));
  case which of
    (0): cause EX1;
    (1): do_cause_EX1or2 (1);
    (2): do_cause_EX1or2 (2);
    (3): cause EX3;
  esac
  on
    (EX1):
	chprintf("(In EX1 handler)^J", 0);
    (EX99, EX2):
	chprintf("(In EX2 handler)^J", 0);
    else
	chprintf("(In ELSE handler)^J", 0);
 end;
end;

test(0);
test(1);
test(2) ON (PROTECTIONFAIL, 
            RANGEFAIL, SPACEFAIL):  CAUSE POOLFAIL ; 
        END;
test(3) ON (PROTECTIONFAIL, 
            RANGEFAIL, SPACEFAIL):  CAUSE POOLFAIL ; 
        END;

end except1;
