/* GNU CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

inits: module

GRANT ALL PREFIXED;

syn s1 int = 10;
syn s2 int = s1 + 10;
SYNMODE bit_16 = BIT(16);
SYNMODE bit_16p = POWERSET INT (0:15);
SYN s_16p1 bit_16p = [4, 6:9, 14];
DCL d_16p1 bit_16p := s_16p1;

dcl a1 array (1:s1) int;
dcl a2 array (1:s2) int;

newmode stru1 = struct (i int, b bool);
syn stru1syn array (1:10) stru1 = [ (*): [1, true] ];

--syn syn1 array (1:5) int = [ 1, 2, 3, 4, 5 ];

syn syn2 array (1:5) int = [ (1,2): 4, (4, 5): 10, (3): 5 ]; /* segfault during
grant */

--syn syn3 array (1:5) int = [ (1,2): 4, (3): 5 ]; /* must be an error */

SYN lower_byte_mask	bit_16 = H'FF_00';
SYN lsb			bit_16 = h'80_00';
SYN dsyn1		INT = 1234;
SYN dsyn2		INT = d'2345;
SYN dsyn3		INT = D'1_2_3_4;

DCL d_dsyn2 INT := dsyn2;

/* numeric conversion mode */

NEWMODE num_conv_mode = SET (octal, decimal, hex);

/* conversion tables */

--SYN btbl ARRAY (num_conv_mode) INT = [8, 10, 16];

syn ten int = 10;
syn twelve = ten + 2;

dcl hextbl ARRAY (0:15) CHAR := ['0','1','2','3','4','5','6','7',
		                '8','9','A','B','C','D','E','F'];
SYN montab ARRAY (1:twelve) CHARS(3) = [
    'JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN',
    'JUL', 'AUG', 'SEP', 'OCT', 'NOV', 'DEC'];


SYNMODE m_statset = SET (tone_voice,
                         connected,
                         conf_active,
                         conf_passive,
                         call_wait,
                         intrus_active,
                         intrus_passive);

SYN s_i1 INT = 0;
SYN s_i2 INT = -5;
SYN s_i3 INT = 5;
SYN s_s1 m_statset = tone_voice;
SYN s_s2 m_statset = intrus_passive;
SYN s_b1 BOOL = TRUE;
SYN s_b2 BOOL = FALSE;
SYN s_c1 CHAR = ' ';
SYN s_c2 CHAR = '0';
SYN s_c3 CHAR = 'A';
SYN s_c4 CHAR = 'z';

SYNMODE m_tss = POWERSET m_statset;

SYN s_statset m_statset = conf_passive;
SYN s_tss m_tss = [tone_voice, conf_active, call_wait];
DCL d_tss m_tss := s_tss;

SYNMODE m_chars = RANGE ('A':'Z');
SYN s_char m_chars = 'A';

NEWMODE xx_char_range = RANGE (c'1e':c'91');
--NEWMODE xx_char_range = RANGE (char(30):char(145));
DCL yy_char_range xx_char_range;

SYNMODE m_charset = POWERSET m_chars;
--SYN s_charset m_charset = ['A', 'C', 'X', 'Y', 'Z'];

NEWMODE test_mod_1 = STRUCT (a INT,
                             b CHAR(10),
                             c ARRAY (1:10) CHAR(4),
			     d m_tss,
			     e m_charset
                            );

NEWMODE test_mod_2 = STRUCT (d num_conv_mode,
                             e ARRAY (1:15) test_mod_1,
                             added ARRAY (1:10) INT
                            );

SYNMODE m_statset_1 = m_statset (connected:call_wait);

SYNMODE m_numset = RANGE (1:100);

SYNMODE ran_10_30 = RANGE (10:30);

SYNMODE ran_1000_1000 = RANGE (-1000:1000);

SYNMODE m_test = POWERSET m_numset;

SYNMODE signed_numb = RANGE (-10:10);
SYNMODE signed_ps = POWERSET signed_numb;
DCL s_pbool POWERSET BOOL;
DCL d_b3 BIT(3) := B'101';
SYN s_b19 BOOLS(19) = B'0111010101010100010';
DCL d_b19 BOOLS(19) := s_b19;
SYN s_b35 BOOLS(35) = B'11110000111100001111000011110000111';
DCL d_b35 BIT(35) := s_b35;
DCL d_b19arr ARRAY (1:3) BIT(19) := [B'1111000011110000111',
				    B'1100110011001100110',
				    B'1110001110001110001'];

--SYNMODE element = STRUCT (data INT,
--                          next REF helem,
--			  xxxx helem1);
-- NOTE: last field causes cc1chill to seg fault...
--helem1 = REF element;
--SYN s_element element = [1111, NULL, NULL];

--SYNMODE helem = element;

/*
NEWMODE variant_with_ps_var = STRUCT (CASE OF
					: b INT,
					: c m_charset,
					: d m_tss,
					: f POWERSET m_statset,
					: e BOOL,
					: g REF test_mod_1
				      ESAC);

NEWMODE variant_with_ps = STRUCT (a INT,
				  z REF test_mod_1,
				  xx variant_with_ps_var);
				  CASE OF
				     : b INT,
				     : c m_charset,
				     : d m_tss,
				     : f POWERSET m_statset,
				     : e BOOL,
				     : g REF test_mod_1
				  ESAC);
*/

NEWMODE int_arr = ARRAY (0:10) INT;
NEWMODE char_5 = CHAR(5);
NEWMODE char_arr = ARRAY (200:210) char_5;
NEWMODE bool_arr = ARRAY (-10:10) BOOL;
NEWMODE bool_arr_2 = ARRAY (-10:10) bool_arr;

NEWMODE s_1 = STRUCT (i_1 INT,
		      b_1 BOOL);

NEWMODE s_2 = STRUCT (second s_1,
                      realy_complex test_mod_2,
                      i_2 INT,
                      b_2 BOOL);

NEWMODE s_3 = STRUCT (i_3 INT,
                      fourth s_1,
                      b_3 BOOL);

NEWMODE complex = STRUCT (first_1  s_2,
                          i        INT,
                          b        BOOL,
                          third    s_3);

NEWMODE arr_mode = ARRAY (1:10) INT;

NEWMODE ptr_arr_mode = ARRAY (1:10) REF INT;

SYNMODE char_index = RANGE ('0':'Z');

SYNMODE set_index = SET (index_1,
                         index_2,
                         index_3,
                         index_4,
                         index_5,
                         index_6,
                         index_7,
                         index_8,
                         index_9,
                         index_10);

SYNMODE set_index_1 = RANGE (index_2:index_7);

NEWMODE arr_bool = ARRAY (BOOL) INT;

NEWMODE arr_char = ARRAY (char_index) INT;

NEWMODE arr_set = ARRAY (set_index) INT;

SYNMODE struc_const_struc = STRUCT (i INT,
                                    b BOOL,
                                    c_4 CHAR(4));

--SYN struc_const struc_const_struc = [10,TRUE,'abcd'];

--SYN s_setarr arr_set = [ 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ];

/* declare a buffer */

NEWMODE file_name = CHAR (20);
NEWMODE user_id = INT(0:31);
NEWMODE queue_entry = STRUCT (user user_id,
                              file file_name,
                              times INT);
--DCl sys_print BUFFER queue_entry;
--DCL another_buffer BUFFER INT;

/* declare a signal */

NEWMODE tsig1 = STRUCT (inst INSTANCE,
			i    INT,
			qe   queue_entry);
NEWMODE tsig2 = STRUCT (inst INSTANCE);
--SIGNAL sig1 = (tsig1);
--SIGNAL sig2 = (tsig2);

/* declare relation modes */

NEWMODE test_rel = STRUCT (el1 CHAR(10),
			   el2 arr_mode,
			   el3 s_1,
			   el4 ARRAY (1:5) s_1,
			   el5 ARRAY (1:5) arr_mode);
/*
SYN s_test_rel test_rel = [ '0123456789',
			    [ 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ],
			    [ 100, TRUE ],
			    [ [101, TRUE], [102, FALSE], [103, TRUE],
			      [104, FALSE], [105, TRUE] ],
			    [ [100, 101, 102, 103, 104, 105, 106, 107, 108, 109],
			      [100, 101, 102, 103, 104, 105, 106, 107, 108, 109],
			      [100, 101, 102, 103, 104, 105, 106, 107, 108, 109],
			      [100, 101, 102, 103, 104, 105, 106, 107, 108, 109],
			      [100, 101, 102, 103, 104, 105, 106, 107, 108, 109] ]
			  ];
*/
/* variant records */
/*
NEWMODE a_variant_1_var = STRUCT (CASE OF
				    : bb INT,
				    : ccc CHAR(5),
				    : dddd ARRAY(1:10) INT,
				    : eeeee ARRAY(1:20) byte,
				    : ffffff queue_entry
				  ESAC);

NEWMODE a_variant_1 = STRUCT (a INT,
			      xx a_variant_1_var);
                              CASE a OF
                                 (1): bb INT,
                                 (2): ccc CHAR(5),
                                 (3): dddd ARRAY(1:10) INT,
                                 (4): eeeee ARRAY(1:20) byte
                                 ELSE ffffff queue_entry
                              ESAC
                              );

SYN s_var1 a_variant_1 = [ .a: 10,
			   .xx: [
				.ffffff:[
				 .user: 2,
				 .file: '12345678901234567890',
				 .times: 100 ] ]
			 ];
*/
NEWMODE a_var_2_var_struc = STRUCT (ccc CHAR(5),
				    dddd CHAR(5),
				    eeeee CHAR(5));
/*
NEWMODE a_variant_2_var = STRUCT ( CASE OF
				     : bb INT,
				     : xx a_var_2_var_struc
				     : ccc,dddd, eeeee CHAR(5)
				   ESAC);

NEWMODE a_variant_2 = STRUCT (a SET (otto,rudi,peter),
			      xx a_variant_2_var );
                              CASE OF
                                 : bb INT,
                                 : ccc,dddd,eeeee CHAR(5)
                              ESAC
                             );

NEWMODE a_variant_3 = STRUCT (ele_1 ARRAY(1:20) INT,
                              ele_2 a_variant_1,
                              ele_3 CHAR(10),
			      ele_4 CHAR(100) VARYING);

NEWMODE a_variant_4 = STRUCT (CASE OF
                                 : x INT,
                                 : y CHAR (5),
                                 : z a_variant_1,
				 : yy CHAR(100) VARYING
                              ESAC
                             );

NEWMODE a_variant_5_var = STRUCT (CASE OF
				    : x INT,
				    : yy ARRAY (1:10) a_variant_1
				  ESAC);

NEWMODE a_variant_5 = STRUCT (CASE OF
                                 : aa INT,
                                 : bbb a_variant_5_var,
					      STRUCT (CASE OF
                                                  : x INT,
                                                  : yy ARRAY (1:10) a_variant_1
                                               ESAC),
                                 : cccc a_variant_2
                              ESAC
                             );
*/
/* varyings */

NEWMODE varying_char = CHAR(100) VARYING;
--NEWMODE varying_int = ARRAY (1:10) VARYING INT;
--SYN s_varint varying_int = [100, 200, 300];

--NEWMODE varying_char_arr = ARRAY (1:10) VARYING varying_char;
--SYN s_arrvarchar varying_char_arr = [ 'grandee', 'juan', 'and', 'others' ];
/*
NEWMODE varying_int_arr = ARRAY (1:10) VARYING varying_int;
SYN s_arrvarint varying_int_arr = [ [100, 200, 300],
				    [101, 201, 301],
				    [102, 202, 302] ];
*/

--grant bit_16, lower_byte_mask;

s_pbool := [TRUE];
end inits;
