<> RANGE_OFF <>
--
-- Knuth-Morris-Pratt-Algorithm
--
kmp: MODULE

SYN CHIL  = "The CCITT High Level Languag"; 
SYN CHILL = "The CCITT High Level Language"; 

SYN MaxAreLen = 10000;
SYN MaxPatLen = 100;

SYNMODE m_arena = CHARS ( MaxAreLen ) VARYING;
SYNMODE m_pattern = STRUCT (
  pat CHARS ( MaxPatLen ) VARYING,
  dif ARRAY ( 0 : MaxPatLen-1 ) INT
);

DCL s, t, u m_arena;
DCL p m_pattern;
DCL i, j INT;

InitPattern: PROC( p m_pattern LOC, ps CHARS (MaxPatLen) VARYING );
  DCL i, j INT;
  DCL c CHAR;
  p.pat := ps; 
  -- compute table of shift distances
  DO WITH p;
    i := 0; j := -1;
    dif(0) := -1;
    DO WHILE i < LENGTH(pat) - 1;
      DO WHILE j >= 0 AND pat(i) /= pat(j);
        j := dif(j);
      OD;
      i +:= 1;  j +:= 1;
      dif(i) := IF pat(i) = pat(j) THEN dif(j) ELSE j FI;
    OD;
  OD;
END InitPattern;

PatLen: PROC( p m_pattern LOC ) RETURNS (INT);
  RETURN LENGTH( p.pat );
END PatLen;

SearchForPat: PROC( p m_pattern LOC, s READ m_arena LOC )
              RETURNS (INT);
  DCL i, j INT;
  DCL lp INT := PatLen( p );
  DCL lt INT := LENGTH( s );
  i := 0; j := 0;
  DO WHILE j < lp AND i < lt;
    DO WHILE j >= 0 AND s(i) /= p.pat(j);
      j := p.dif(j);
    OD;
    i +:= 1;  j +:= 1;
  OD;
   
  RETURN IF j = lp THEN i-j ELSE LENGTH( p.pat ) FI;
END SearchForPat;

fillarena: PROC( b m_arena LOC, thepos INT OUT );
  SYN times = 300;
  DCL a CHARS (times*LENGTH(CHIL)+LENGTH(CHILL));
  DCL i, j, k INT;
  DCL c CHAR;
  k := 0;
  DO FOR i := 1 TO times;
    a(k UP LENGTH(CHIL)) := CHIL;
    k +:= LENGTH(CHIL);
  OD;
  thepos := k;
  a(k UP LENGTH(CHILL)) := CHILL;
  b := a;
END fillarena;

InitPattern( p, CHILL );

fillarena( s, j );

WRITETEXT( stdout, """%C"" ", p.pat );
i := SearchForPat( p, s );
IF i = PatLen( p ) THEN
  WRITETEXT( stdout, "not found%/" );
ELSE
  WRITETEXT( stdout, "found at offset %C, should be at %C%/", i, j );
FI;

END kmp;
