/* GNU CHILL compiler regression test output functions
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <stdio.h>

typedef struct
{
  short	len;
  char	body[100];
} TVarying;

void
empty_line ()
{
  printf ("\n");
}

void
outchar (str, len)
     char *str;
     int len;
{
  char *out = alloca ((len * 5) + 2);
  int i;
  char *p = out;
  
  if (str == NULL)
    return;

  for (i = 0; i < len; i++)
    {
      if (str[i] >= ' ' && str[i] <= '~')
	*p++ = str[i];
      else
	{
	  sprintf (p, "\\%02X", (unsigned)str[i]);
	  p += strlen (p);
	}
    }
  *p = '\0';
  printf ("\"%s\"\n", out);
}

void
outvarchar (string)
     TVarying *string;
{
  outchar (string->body, string->len);
#if 0
  char	*str;
    
  str = alloca (string->len + 10);
  memcpy (str, string->body, string->len);
  str[string->len] = '\0';
  printf ("\"%s\"\n", str);
#endif
}

void
achilles (string, p)
     TVarying *string;
     void * p;
{
  outvarchar (string);
}

void
outint (val)
     short val;
{
  printf ("%d\n", val);
}

#ifndef SET_WORD
#define SET_WORD unsigned int
#endif

void
outpowerset_set (ps, min, max, strtab)
     char *ps;
     int min, max;
     char **strtab;
{
  unsigned elem;

  if (ps == NULL || strtab == NULL)
    return;

  printf ("[ ");
  for (elem = min; elem <= max; elem++)
    if (__inpowerset ((unsigned)elem, (SET_WORD *)ps,
		     (unsigned)(max - min + 1),
		     (unsigned)min))
      printf ("%s ", strtab[elem]);
  printf ("]\n");
}

void
outpowerset_bool (ps)
    char *ps;
{
  unsigned elem;
  
  if (ps == NULL)
    return;
  
  printf ("[ ");
  if (__inpowerset (0, (SET_WORD *)ps,
		    2, 0))
    printf ("FALSE ");
  if (__inpowerset (1, (SET_WORD *)ps,
		    2, 0))
    printf ("TRUE ");
  printf ("]\n");
}

void
outpowerset_char (ps, min, max)
     char *ps;
     char min, max;
{
  unsigned elem;
  
  printf ("[ ");
  for (elem = min; elem <= max; elem++)
    {
      if (__inpowerset ((unsigned)elem, (SET_WORD *)ps,
			(unsigned)(max - min + 1),
			(unsigned)min))
	{
	  if (elem >= ' ' && elem <= '~' && elem != '\'')
	    printf ("'%c' ", elem);
	  else
	    printf ("C'%02X' ", elem);
	}
    }
  printf ("]\n");
}

void
outpowerset_int (ps, min, max)
    char *ps;
    int min, max;
{
  int elem;
  
  if (ps == NULL)
    return;

  printf ("[ ");
  for (elem = min; elem <= max; elem++)
    {
      if (__inpowerset ((unsigned)elem, (SET_WORD *)ps,
			(unsigned)(max - min + 1),
			(unsigned)min))
	printf ("%d ", elem);
    }
  printf ("]\n");
}
