/* GNU CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */
outtest: MODULE

<> USE_SEIZE_FILE 'choutput.grt' <>
SEIZE outpowerset_set;

NEWMODE aset = SET (a, b, c,
                    a1, b1, c1,
                    a2, b2, c2,
                    a3, b3, c3,
                    a4, b4, c4,
                    a5, b5, c5,
                    a6, b6, c6,
                    a7, b7, c7,
                    a8, b8, c8,
                    a9, b9, c9,
                    a10, b10, c10,
                    a11, b11, c11,
                    a12, b12, c12,
                    a13, b13, c13,
                    a14, b14, c14,
                    a15, b15, c15
                   );
NEWMODE ps_set = POWERSET aset;

DCL enum_a CHAR(2) := "a" // C'00';
DCL enum_b CHAR(2) := "b" // C'00';
DCL enum_c CHAR(2) := "c" // C'00';

DCL enumtab ARRAY (0:2) REF CHAR (2) := 
 [
    ->enum_a,
    ->enum_b,
    ->enum_c
 ];

p: PROC () RETURNS ( ps_set );
   RETURN [];
END p;

pa: PROC () RETURNS ( ps_set );
   RETURN [a];
END pa;

pb: PROC () RETURNS ( ps_set );
   RETURN [b];
END pb;

pc: PROC () RETURNS ( ps_set );
   RETURN [c];
END pc;

pab: PROC () RETURNS ( ps_set );
   RETURN [a,b];
END pab;

pac: PROC () RETURNS ( ps_set );
   RETURN [a,c];
END pac;

pbc: PROC () RETURNS ( ps_set );
   RETURN [b,c];
END pbc;

pabc: PROC () RETURNS ( ps_set );
   RETURN [a,b,c];
END pabc;

tests: PROC ();

   DCL res ps_set;

   res := p ();
   outpowerset_set (ADDR (res), INT (LOWER (aset)), INT (UPPER (aset)), ADDR (enumtab));
   res := pa ();
   outpowerset_set (ADDR (res), INT (LOWER (aset)), INT (UPPER (aset)), ADDR (enumtab));
   res := pb ();
   outpowerset_set (ADDR (res), INT (LOWER (aset)), INT (UPPER (aset)), ADDR (enumtab));
   res := pc ();
   outpowerset_set (ADDR (res), INT (LOWER (aset)), INT (UPPER (aset)), ADDR (enumtab));
   res := pab ();
   outpowerset_set (ADDR (res), INT (LOWER (aset)), INT (UPPER (aset)), ADDR (enumtab));
   res := pac ();
   outpowerset_set (ADDR (res), INT (LOWER (aset)), INT (UPPER (aset)), ADDR (enumtab));
   res := pbc ();
   outpowerset_set (ADDR (res), INT (LOWER (aset)), INT (UPPER (aset)), ADDR (enumtab));
   res := pabc ();
   outpowerset_set (ADDR (res), INT (LOWER (aset)), INT (UPPER (aset)), ADDR (enumtab));

END tests;

tests ();

END outtest;
