/* GNU CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */
procmode_: MODULE

--<> USE_SEIZE_FILE 'chprintf.grt' <>
--SEIZE chprintf, printlreal;

SYNMODE Telnr = LONG;

-- Now, a mode that describes all of the procedures so far
SYNMODE Operations = PROC (Telnr, Telnr)
                     RETURNS (BOOL) EXCEPTIONS (wrong_nr);
GRANT Operations;

DCL next_, first_ Operations;

-- first, some declarations
connecting: PROC (incoming, outgoing Telnr) 
RETURNS (BOOL) EXCEPTIONS (wrong_nr);
  WRITETEXT (stdout, "connecting (%C, %C) called%/", incoming, outgoing);
--  chprintf ("connecting (%d, ", incoming);
--  chprintf ("%d) called^J", outgoing);
  RETURN incoming = outgoing;
END connecting;

holding:  PROC (sideA, sideB Telnr)
RETURNS (BOOL) EXCEPTIONS (wrong_nr);
  WRITETEXT (stdout, "holding (%C, %C) called%/", sideA, sideB);
--  chprintf ("holding (%d, ", sideA);
--  chprintf ("%d) called^J", sideB);
  RETURN sideA = sideB;
END holding;

breaking:  PROC (caller, called Telnr)
RETURNS (BOOL) EXCEPTIONS (wrong_nr);
  WRITETEXT (stdout, "breaking (%C, %C) called%/", caller, called);
--  chprintf ("breaking (%d, ", caller);
--  chprintf ("%d) called^J", called);
  RETURN caller = called;
END breaking;

next_ := NULL;
first_ := connecting;

IF first_ = connecting THEN
  next_ := holding;
FI;

IF first_ (5551212, 5551212) = TRUE THEN
  WRITETEXT (stdout, "connecting (a, a) succeeded%/");
--  chprintf ("connecting (a, a) succeeded^J", 0);
FI;

IF first_ (5551212, 5551212) = TRUE THEN
  WRITETEXT (stdout, "connecting (a, a) succeeded%/");
--  chprintf ("connecting (a, a) succeeded^J", 0);
FI;

IF next_ (8531212, 5551212) = TRUE THEN
  WRITETEXT (stdout, "holding (a, b) succeeded%/");
--  chprintf ("holding (a, b) succeeded^J", 0);
ELSE
  WRITETEXT (stdout, "holding (a, b) failed%/");
--  chprintf ("holding (a, b) failed^J", 0);
FI;

END procmode_;
