/* CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */
rdtext: MODULE

--
-- testcase for READTEXT
--

-- string where we format in to read it back
NEWMODE wrk_mode = CHARS(200) VARYING;
DCL wrk wrk_mode;

DCL byte_test_string CHAR(40) VARYING := "is_a_byte = %C";
DCL is_a_byte BYTE := 10;

NEWMODE is_a_set = SET (UNUSED, hugo, ist, da);
DCL set1, set2, set3 is_a_set;
DCL set_test_string CHAR(40) VARYING := "set1 = %c, set2 = %c, set3 = %c";

DCL is_charvary CHARS(40) VARYING;
DCL charvar_test_string CHARS(40) VARYING := "byte = H'%H, str = %c";

DCL rep1, rep2, rep3, rep4, rep5 INT;
DCL rep_test_string CHARS(40) VARYING := "5 INT's = %5H4";
DCL rep_test_string_l CHARS(40) VARYING := "5 INT's = %5HL4";
DCL rep_test_string_p CHARS(40) VARYING := "5 INT's = %5HP#4";
DCL rep_test_string_lp CHARS(40) VARYING := "5 INT's = %5HLp$4";

DCL b8 BOOLS(8), b35 BOOLS(35);
DCL bit_test_string_out CHARS(40) VARYING := "%C, %C";
DCL bit_test_string_in CHARS(40) VARYING := "B'%C', B'%C'";

newline: PROC () INLINE;
   WRITETEXT (stdout, "%/");
END newline;

generated: PROC ();
   WRITETEXT (stdout, "=== Generated: %c%/", wrk);
END generated;

WRITETEXT (stdout, "%/***** Bit Strings *****%/");
b8 := B'10101010'; b35 := B'00001111000011110000111100001111010';
WRITETEXT (wrk, bit_test_string_out, b8, b35); generated ();
b8 := B'00000000'; b35 := B'00000000000000000000000000000000000';
READTEXT (wrk, bit_test_string_in, b8, b35);
WRITETEXT (stdout, bit_test_string_out, b8, b35); newline ();

WRITETEXT (stdout, "%/***** Testing Repetitions *****%/");
rep1 := h'f1; rep2 := h'f2; rep3 := h'f3; rep4 := h'f4; rep5 := h'f5;
WRITETEXT (wrk, rep_test_string, rep1, rep2, rep3, rep4, rep5); generated ();
rep1, rep2, rep3, rep4, rep5 := 0;
READTEXT (wrk, rep_test_string, rep1, rep2, rep3, rep4, rep5);
WRITETEXT (stdout, rep_test_string, rep1, rep2, rep3, rep4, rep5);
newline ();

rep1 := h'd1; rep2 := h'd2; rep3 := h'd3; rep4 := h'd4; rep5 := h'd5;
WRITETEXT (wrk, rep_test_string_p, rep1, rep2, rep3, rep4, rep5); generated ();
rep1, rep2, rep3, rep4, rep5 := 0;
READTEXT (wrk, rep_test_string_p, rep1, rep2, rep3, rep4, rep5);
WRITETEXT (stdout, rep_test_string_p, rep1, rep2, rep3, rep4, rep5);
newline ();

rep1 := h'e1; rep2 := h'e2; rep3 := h'e3; rep4 := h'e4; rep5 := h'e5;
WRITETEXT (wrk, rep_test_string_l, rep1, rep2, rep3, rep4, rep5); generated ();
rep1, rep2, rep3, rep4, rep5 := 0;
READTEXT (wrk, rep_test_string_l, rep1, rep2, rep3, rep4, rep5);
WRITETEXT (stdout, rep_test_string_l, rep1, rep2, rep3, rep4, rep5);
newline ();

rep1 := h'c1; rep2 := h'c2; rep3 := h'c3; rep4 := h'c4; rep5 := h'c5;
WRITETEXT (wrk, rep_test_string_lp, rep1, rep2, rep3, rep4, rep5); generated ();
rep1, rep2, rep3, rep4, rep5 := 0;
READTEXT (wrk, rep_test_string_lp, rep1, rep2, rep3, rep4, rep5);
WRITETEXT (stdout, rep_test_string_lp, rep1, rep2, rep3, rep4, rep5);
newline ();

WRITETEXT (stdout, "%/***** Testing Byte *****%/");
WRITETEXT (wrk, byte_test_string, is_a_byte); generated ();
is_a_byte := 0;
READTEXT (wrk, byte_test_string, is_a_byte);
WRITETEXT (stdout, byte_test_string, is_a_byte);
newline();

is_a_byte := -126;
WRITETEXT (wrk, byte_test_string, is_a_byte); generated ();
is_a_byte := 0;
READTEXT (wrk, byte_test_string, is_a_byte);
WRITETEXT (stdout, byte_test_string, is_a_byte);
newline();

WRITETEXT (wrk, byte_test_string, 255);
generated ();
is_a_byte := 0;
READTEXT (wrk, byte_test_string, is_a_byte) ON (textfail):
  WRITETEXT (stdout, byte_test_string, is_a_byte); WRITETEXT (stdout, " >>>> Byte Textfail PASSED");
  newline(); goto byte_p_passed; END;
WRITETEXT (stdout, byte_test_string, is_a_byte);
WRITETEXT (stdout, " <<<< Byte Textfail FAILED%/");

byte_p_passed:
WRITETEXT (wrk, byte_test_string, -129);
generated ();
is_a_byte := 0;
READTEXT (wrk, byte_test_string, is_a_byte) ON (textfail):
  WRITETEXT (stdout, byte_test_string, is_a_byte); WRITETEXT (stdout, " >>>> Byte Textfail PASSED");
  newline(); goto byte_n_passed; END;
WRITETEXT (stdout, byte_test_string, is_a_byte);
WRITETEXT (stdout, " <<<< Byte Textfail FAILED%/");

byte_n_passed:
is_a_byte := 0;

WRITETEXT (stdout, "%/***** Testing Enum's *****%/");
set1 := hugo; set2 := ist; set3 := da;
WRITETEXT (wrk, set_test_string, set1, set2, set3);
generated ();
set1, set2, set3 := unused;
READTEXT (wrk, set_test_string, set1, set2, set3);
WRITETEXT (stdout, set_test_string, set1, set2, set3);
newline ();
set1, set2, set3 := unused;
wrk := wrk(0 UP LENGTH(wrk) - 2);
wrk := wrk // "DA";
generated ();
READTEXT (wrk, set_test_string, set1, set2, set3) ON (textfail):
  WRITETEXT (stdout, set_test_string, set1, set2, set3);
  WRITETEXT (stdout, " >>>> Enum Textfail PASSED");
  newline (); goto enum_passed; END;
WRITETEXT (stdout, set_test_string, set1, set2, set3);
WRITETEXT (stdout, " <<<< Enum Textfail FAILED%/");

enum_passed:
set1, set2, set3 := unused;

WRITETEXT (stdout, "%/***** Testing Chars(n) Varying *****%/");
is_a_byte := 97; is_charvary := """Hugo ist da.""";
WRITETEXT (wrk, charvar_test_string, is_a_byte, is_charvary);
generated ();
is_a_byte := 0; is_charvary := "";
READTEXT (wrk, charvar_test_string, is_a_byte, is_charvary);
WRITETEXT (stdout, charvar_test_string, is_a_byte, is_charvary);
newline ();
is_a_byte := 0; is_charvary := "";
wrk(9 up 2) := "21";
wrk := wrk(0:LENGTH(wrk) - 3);
wrk := wrk // " und dort.""";
generated();
READTEXT (wrk, charvar_test_string, is_a_byte, is_charvary);
WRITETEXT (stdout, charvar_test_string, is_a_byte, is_charvary);
newline ();

END rdtext;
