/* GNU CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

rexpr: MODULE

  <> use_seize_file 'chprintf.grt' <>
  seize chprintf, printlreal;

dcl ra real := 3.1415926, 
    rb real := 2.71828,
    rc real := 1.7e-3,
    rd real := 1.0, 
    re real := 2.0, 
    rf real := 4.5;

real_function:
PROC (real1 REAL IN) RETURNS (REAL);
     RETURN real1 + re;
END real_function;

WRITETEXT (stdout, "ra = %R%/", ra);--printlreal ("ra = %lf^J", ra);
WRITETEXT (stdout, "rb = %R%/", rb);--printlreal ("rb = %lf^J", rb);
WRITETEXT (stdout, "rc = %R%/", rc);--printlreal ("rc = %lf^J", rc);
WRITETEXT (stdout, "rd = %R%/", rd);--printlreal ("rd = %lf^J", rd);
WRITETEXT (stdout, "re = %R%/", re);--printlreal ("re = %lf^J", re);
WRITETEXT (stdout, "rf = %R%/", rf);--printlreal ("rf = %lf^J", rf);
WRITETEXT (stdout, "rb + rc = %R%/", rb + rc);--printlreal ("rb + rc = %lf^J", rb + rc);                     -- real expressions
WRITETEXT (stdout, "rb - rc = %R%/", rb - rc);--printlreal ("rb - rc = %lf^J", rb - rc);
WRITETEXT (stdout, "rb / rc = %R%/", rb / rc);--printlreal ("rb / rc = %lf^J", rb / rc);
WRITETEXT (stdout, "rb * rc = %R%/", rb * rc);--printlreal ("rb * rc = %lf^J", rb * rc);
WRITETEXT (stdout, "((rb + rc) * rd + re) * rf = %R%/", ((rb + rc) * rd + re) * rf);--printlreal ("((rb + rc) * rd + re) * rf = %d^J", ((rb + rc) * rd + re) * rf);

WRITETEXT (stdout, "ra <  rb = %C%/", ra < rb);--chprintf ("ra <  rb = %d^J", long(ra <  rb));
WRITETEXT (stdout, "ra >= rb = %C%/", ra >= rb);--chprintf ("ra >= rb = %d^J", long(ra >= rb));
WRITETEXT (stdout, "rb >  rb = %C%/", ra > rb);--chprintf ("ra >  rb = %d^J", long(ra >  rb));
WRITETEXT (stdout, "ra <= rb = %C%/", ra <= rb);--chprintf ("ra <= rb = %d^J", long(ra <= rb));
WRITETEXT (stdout, "ra =  rb = %C%/", ra = rb);--chprintf ("ra =  rb = %d^J", long(ra =  rb));
WRITETEXT (stdout, "ra /= rb = %C%/", ra /= rb);--chprintf ("ra /= rb = %d^J", long(ra /= rb));

if ra > rb then
  WRITETEXT (stdout, "ra > rb%/");--chprintf ("ra > rb^J", 0);
else
  WRITETEXT (stdout, "ra <= rb%/");--chprintf ("ra <= rb^J", 0);
fi;

WRITETEXT (stdout, "real_function (3.6) = %R%/", real_function (3.6));--printlreal ("real_function (3.6) = %lf^J", real_function (3.6));
END rexpr;
