/* GNU CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

SETEXPR: MODULE

  <> use_seize_file 'chprintf.grt' <>
  SEIZE chprintf;

  SYNMODE pb = POWERSET BYTE;

  DCL fred BOOL        := b'0101'  = b'1100',
      bob  BOOL        := b'0101' /= b'1100';

  DCL letterset POWERSET CHAR, 
      l1 POWERSET CHAR,
      l2 POWERSET CHAR,
      l3 POWERSET CHAR,
      l4, l5, l6, l7 pb;

DCL i INT;
DCL ch CHAR;

l1 := [ 'a', 'b', 'c' ];
l2 := [ 'a', 'b' ];
l3 := [ 'a', 'b', 'c' ];
l4 := pb[ 0, 2 ] AND pb[ 0, 1 ];
l5 := pb[ 0, 2 ]  OR pb[ 0, 1 ];
l6 := pb[ 0, 2 ] XOR pb[ 0, 1 ];
l7 := pb[ 0, 2 ]  -  pb[ 0, 1 ];

chprintf ("l1 <  l2 = %d^J", LONG (l1 <  l2));
chprintf ("l1 >= l2 = %d^J", LONG (l1 >= l2));

chprintf ("l1 <= l2 = %d^J", LONG (l1 <= l2));
chprintf ("l1 >  l2 = %d^J", LONG (l1 >  l2));

chprintf ("(l1 < l2) AND (l1 < l3) = %d^J", LONG ((l1 < l2) AND (l1 < l3)));

chprintf ("l1 =  l2 = %d^J", LONG (l1 =  l2));
chprintf ("l1 /= l2 = %d^J", LONG (l1 /= l2));

letterset := l1 AND l2;
chprintf ("l1 AND l2^J", 0);
IF 'a' IN letterset THEN
  chprintf ("'a' in letterset^J", 0);
FI;
IF 'b' IN letterset THEN
  chprintf ("'b' in letterset^J", 0);
FI;
IF 'c' IN letterset THEN
  chprintf ("'c' in letterset^J", 0);
FI;
IF 'd' IN letterset THEN
  chprintf ("'d' in letterset^J", 0);
FI;
IF 'z' IN letterset THEN
  chprintf ("'z' in letterset^J", 0);
FI;

letterset := l1 XOR l2;
chprintf ("l1 XOR l2^J", 0);
IF 'a' IN letterset THEN
  chprintf ("'a' in letterset^J", 0);
FI;
IF 'b' IN letterset THEN
  chprintf ("'b' in letterset^J", 0);
FI;
IF 'c' IN letterset THEN
  chprintf ("'c' in letterset^J", 0);
FI;
IF 'd' IN letterset THEN
  chprintf ("'d' in letterset^J", 0);
FI;
IF 'z' IN letterset THEN
  chprintf ("'z' in letterset^J", 0);
FI;

letterset := l1 OR l2;
chprintf ("l1 OR l2^J", 0);
IF 'a' IN letterset THEN
  chprintf ("'a' in letterset^J", 0);
FI;
IF 'b' IN letterset THEN
  chprintf ("'b' in letterset^J", 0);
FI;
IF 'c' IN letterset THEN
  chprintf ("'c' in letterset^J", 0);
FI;
IF 'd' IN letterset THEN
  chprintf ("'d' in letterset^J", 0);
FI;
IF 'z' IN letterset THEN
  chprintf ("'z' in letterset^J", 0);
FI;

letterset := l1 - l2;
chprintf ("l1 - l2^J", 0);
IF 'a' IN letterset THEN
  chprintf ("'a' in letterset^J", 0);
FI;
IF 'b' IN letterset THEN
  chprintf ("'b' in letterset^J", 0);
FI;
IF 'c' IN letterset THEN
  chprintf ("'c' in letterset^J", 0);
FI;
IF 'd' IN letterset THEN
  chprintf ("'d' in letterset^J", 0);
FI;
IF 'z' IN letterset THEN
  chprintf ("'z' in letterset^J", 0);
FI;

letterset := NOT l1;
chprintf ("NOT l1^J", 0);
IF 'a' IN letterset THEN
  chprintf ("'a' in letterset^J", 0);
FI;
IF 'b' IN letterset THEN
  chprintf ("'b' in letterset^J", 0);
FI;
IF 'c' IN letterset THEN
  chprintf ("'c' in letterset^J", 0);
FI;
IF 'd' IN letterset THEN
  chprintf ("'d' in letterset^J", 0);
FI;
IF 'z' IN letterset THEN
  chprintf ("'z' in letterset^J", 0);
FI;

letterset := (l1 OR l2) AND l3;
chprintf ("(l1 OR l2) AND l3^J", 0);
IF 'a' IN letterset THEN
  chprintf ("'a' in letterset^J", 0);
FI;
IF 'b' IN letterset THEN
  chprintf ("'b' in letterset^J", 0);
FI;
IF 'c' IN letterset THEN
  chprintf ("'c' in letterset^J", 0);
FI;
IF 'd' IN letterset THEN
  chprintf ("'d' in letterset^J", 0);
FI;
IF 'z' IN letterset THEN
  chprintf ("'z' in letterset^J", 0);
FI;

chprintf ("'c' IN l1 = %d^J", LONG ('c' IN l1));

END setexpr;
