/* GNU CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

-- The appropriate equivalent C code:
--
--|/* Now the tasking structure: */
--|
--|typedef void (*EntryPoint) ();
--|
--|typedef enum
--|{
--|   _TT_UNUSED,
--|   _TT_Process,
--|   _TT_Signal,
--|   _TT_Buffer,
--|   _TT_Event,
--|} TaskingEnum;
--|
--|typedef struct
--|{
--|   char          *name;
--|   short         *value;
--|   int           value_defined;
--|   EntryPoint    entry;
--|   unsigned char type; /* TaskingEnum */
--|} TaskingStruct;
--|
--|/* as there WAS NO SIGNAL_CODE directive before the definition of
--|   s1, this signal doesn't get a code */
--|static short __tmp_s1_code;
--|
--|/* as there WAS A SIGNAL_CODE directive before the definition of
--|   s2, this signal get a code and the code gets automatically 
--|   inceremented by one for the next SIGNAL definition */ 
--|static short __tmp_s2_code = 20;
--|static short __tmp_s3_code = 21;
--|
--|/* Same mechnism as above is true for PROCESSES */
--|static short __tmp_p1_code;
--|static short __tmp_p2_code = 5;
--|
--|
--|/* now the tasking structs for all that stuff */
--|/* for s1 */
--|static TaskingStruct __tmp_s1_struct =
--|{
--|   "s1",
--|   &__tmp_s1_code,
--|   0,		/* there is no value defined */
--|   0,		/* a signal doesn't have an entry */
--|   _TT_Signal   /* yes, it's a signal */
--|};
--|
--|/* for s2 */
--|static TaskingStruct __tmp_s2_struct =
--|{
--|   "s2",
--|   &__tmp_s2_code,
--|   1,		/* there is a value defined */
--|   0,		/* a signal doesn't have an entry */
--|   _TT_Signal   /* yes, it's a signal */
--|};
--|
--|/* for s3 */
--|static TaskingStruct __tmp_s3_struct =
--|{
--|   "s3",
--|   &__tmp_s3_code,
--|   1,		/* there is a value defined */
--|   0,		/* a signal doesn't have an entry */
--|   _TT_Signal   /* yes, it's a signal */
--|};
--|
--|/* for p1 */
--|static TaskingStruct __tmp_p1_struct =
--|{
--|   "p1",
--|   &__tmp_p1_code,
--|   0,		/* there is no value defined */
--|   p1,		/* there is an entrypoint */
--|   _TT_Process  /* yes, it's a process */
--|};
--|
--|/* for p2 */
--|static TaskingStruct __tmp_p2_struct =
--|{
--|   "p2",
--|   &__tmp_p2_code,
--|   1,		/* there is a value defined */
--|   p2,		/* there is an entrypoint */
--|   _TT_Process  /* yes, it's a process */
--|};
--|
--|/* now the constructor */
--|
--|void a ()
--|{
--|   __register_tasking (&__tmp_s1_struct);
--|   __register_tasking (&__tmp_s2_struct);
--|   __register_tasking (&__tmp_s3_struct);
--|   __register_tasking (&__tmp_p1_struct);
--|   __register_tasking (&__tmp_p2_struct);
--|}


signala: MODULE

<> USE_SEIZE_FILE 'chprintf.grt' <>
SEIZE chprintf;

<> USE_SEIZE_FILE 'signalb.grt' <>
SEIZE s1, p1, p2;

SIGNAL s4;

<> SIGNAL_CODE = 3 <>
SIGNAL s5;

SEIZE s2;

DCL ins INSTANCE;

p3: PROCESS ()
END p3;

<> PROCESS_TYPE = 8 <>

p4: PROCESS ();
  chprintf ("Hello from p4^J", 0);
END p4;
 
ins := GEN_INST (p2, 5); 
START p4 (-1);
START p2 (5);
SEND s2 TO ins;
END signala;
