/* GNU CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

-- The equivalent C code:
--|
--|/* SEIZEd tasking items in general don't have a number
--|   cause the number may be specified in another module
--|   and the runtime system will this find */
--|static short __tmp_s1_code;
--|static short __tmp_p1_code;
--|static short __tmp_p2_code;
--|
--|/* as there was no SIGNAL_CODE directive before the definition
--|   of s4, this signal doesn't have a code */
--|static short __tmp_s4_code;
--|
--|/* next signal get's a code cause there was a SIGNAL_CODE
--|   definition before */
--|static short __tmp_s5_code = 3;
--|
--|/* SEIZEd tasking stuff has no code */
--|static short __tmp_s2_code;
--|
--|/* now the processes defined in this module. */
--|static short __tmp_p3_code;
--|
--|/* next one gets a number, there was a PROCESS_CODE directive
--|   before */
--|static short __tmp_p4_code = 8;
--|
--|/* now the tasking structs for all the stuff */
--|/* for s1, even is's seized */
--|static TaskingStruct __tmp_s1_struct = 
--|{
--|   "s1",
--|   &__tmp_s1_code,
--|   0,		/* seized stuff has no value defined */
--|   0,		/* a signal has no entry */
--|   _TT_Signal   /* it's a signal */
--|};
--|
--|/* for s2, even is's seized */
--|static TaskingStruct __tmp_s2_struct = 
--|{
--|   "s2",
--|   &__tmp_s2_code,
--|   0,		/* seized stuff has no value defined */
--|   0,		/* a signal has no entry */
--|   _TT_Signal   /* it's a signal */
--|};
--|
--|/* for s4 */
--|static TaskingStruct __tmp_s4_struct = 
--|{
--|   "s4",
--|   &__tmp_s4_code,
--|   0,		/* no value was defined */
--|   0,		/* a signal has no entry */
--|   _TT_Signal   /* it's a signal */
--|};
--|
--|/* for s5 */
--|static TaskingStruct __tmp_s5_struct = 
--|{
--|   "s5",
--|   &__tmp_s5_code,
--|   1,		/* there is a value defined */
--|   0,		/* a signal has no entry */
--|   _TT_Signal   /* it's a signal */
--|};
--|
--|/* for p1 */
--|static TaskingStruct __tmp_p1_struct = 
--|{
--|   "p1",
--|   &__tmp_p1_code,
--|   0,		/* seized stuff has no value defined */
--|   0,		/* seized processes have no entry in this module */
--|   _TT_Process  /* it's a Process */
--|};
--|
--|/* for p2 */
--|static TaskingStruct __tmp_p2_struct = 
--|{
--|   "p2",
--|   &__tmp_p2_code,
--|   0,		/* seized stuff has no value defined */
--|   0,		/* seized processes have no entry in this module */
--|   _TT_Process  /* it's a Process */
--|};
--|
--|/* for p3 */
--|static TaskingStruct __tmp_p3_struct = 
--|{
--|   "p3",
--|   &__tmp_p3_code,
--|   0,		/* no value defined */
--|   p3,		/* process have the entry in this module */
--|   _TT_Process  /* it's a Process */
--|};
--|
--|/* for p4 */
--|static TaskingStruct __tmp_p4_struct = 
--|{
--|   "p4",
--|   &__tmp_p4_code,
--|   1,		/* value defined */
--|   p4,		/* process have an entry in this module */
--|   _TT_Process  /* it's a Process */
--|};
--|
--|/* now the constructor */
--|
--|void b ()
--|{
--|   __register_tasking (&__tmp_s1_struct);
--|   __register_tasking (&__tmp_s2_struct);
--|   __register_tasking (&__tmp_s4_struct);
--|   __register_tasking (&__tmp_s5_struct);
--|   __register_tasking (&__tmp_p1_struct);
--|   __register_tasking (&__tmp_p2_struct);
--|   __register_tasking (&__tmp_p3_struct);
--|   __register_tasking (&__tmp_p4_struct);
--|}

signal_b: MODULE

<> USE_SEIZE_FILE 'chprintf.grt' <>
SEIZE chprintf;

SIGNAL s1;

<> SIGNAL_CODE = 20 <>

SIGNAL s2, s3;

p1: PROCESS ();
END p1;

<> PROCESS_TYPE = 5 <>

p2: PROCESS ()
  chprintf ("Hello from p2^J", 0);
END p2;

GRANT s1, s2, s3, p1, p2;

END signal_b;
