silili: MODULE

SYNMODE
  m_link = REF m_node,
  m_item = INT,
  m_node = STRUCT (data m_item, next m_link);
SYNMODE
  m_list = m_link;

DCL ThePool ARRAY (1:10) m_node := [ (*): m_node[99,NULL] ];
DCL Avail m_list := NULL;

DCL MyList m_list := NULL;
DCL nodep m_link;
DCL i INT;

InitPool: PROC ();
  DCL node m_node ;
  DO FOR node IN ThePool;
    AddList ( node, Avail );
  OD;
END InitPool;

RemList: PROC ( TheList m_list LOC) RETURNS (m_link) EXCEPTIONS (underflow);
  DCL p m_link := TheList;
  IF p = NULL THEN CAUSE underflow; FI;
  TheList := p->.next;
  RETURN p;
END RemList;

AddList: PROC ( TheNode m_node LOC, TheList m_list LOC);
  TheNode.next := TheList;
  TheList := ->TheNode;
--  WRITETEXT( stdout, "%C added%/", TheNode.data );
END AddList;

IsEmpty: PROC ( TheList m_list ) RETURNS (BOOL);
  RETURN TheList = NULL;
END IsEmpty;

match: PROC (key m_item, TheList m_list) RETURNS (m_link);
  DCL curr m_link := TheList;
  DO WHILE curr /= NULL;
     IF key = curr->.data THEN RETURN curr; FI;
     curr:= curr->.next;
  OD;
  RETURN NULL;
END match;

reverse: PROC (TheList m_list INOUT);
  DCL curr m_link := TheList;
  DCL q, r m_link;
   q := NULL;
   DO WHILE curr /= NULL;
      r := curr->.next;
      curr->.next := q;
      q := curr;
      curr := r;
   OD;
   TheList := q;
END reverse;

sort: PROC (first m_link INOUT) RECURSIVE;
   DCL current, before m_link;
   IF first /= NULL THEN
      IF first->.next /= NULL THEN
         /* if more than 1 element in list */
         /* sort tail of the list          */
         sort(first->.next);
         /* search for position to insert first */
         IF first->.data > first->.next->.data THEN 
            before:= first;
            current:= first->.next;
            DO WHILE current->.next /= NULL AND
               first->.data > current->.data;
               before:= current;
               current:= current->.next;
            OD;
            IF first->.data > current->.data THEN 
               /* 1st element at the end */
               current->.next:= first;
               first:= first->.next;
               current->.next->.next:= NULL;
            ELSE /* 1st element within */
               before->.next:= first;
               first:= first->.next;
               before->.next->.next:= current;
            FI;
         FI;
      FI;
   FI;
END sort;

showlist: PROC ( TheList m_list );
  showtail: PROC ( TheTail m_list ) RECURSIVE;
    IF NOT IsEmpty( TheTail ) THEN
      WRITETEXT( stdout, ", %C", TheTail->.data );
      showtail( TheTail->.next );
    FI;
  END showtail;
  IF IsEmpty( TheList ) THEN
    WRITETEXT( stdout, "()%/" );
  ELSE
    WRITETEXT( stdout, "(%C", TheList->.data );
    showtail( TheList->.next );
    WRITETEXT( stdout, ")%/" );
  FI;
END showlist;

WRITETEXT( stdout, "Init Pool%/" );
InitPool();

showlist( MyList );
WRITETEXT( stdout, "Making list%/" );
DO FOR i := 1 TO 10;
  nodep := RemList( Avail );
  nodep->.data := i;
  AddList( nodep->, MyList );
OD;

showlist( MyList );

sort( MyList );
showlist( MyList );

reverse( MyList );
showlist( MyList );

sort( MyList );
showlist( MyList );

END silili;
