/* GNU CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */
start_: MODULE

<> USE_SEIZE_FILE 'chprintf.grt' <>
SEIZE chprintf, printlreal;

<> USE_SEIZE_FILE 'start1.grt' <>
SEIZE p2;
SEIZE s9;

<> USE_SEIZE_FILE 'signal.grt' <>
SEIZE s1, s2, s3, s4;

SIGNAL done;

DCL ch LONG := 123456;
DCL ins INSTANCE;
GRANT ins;
DCL xyz INT;
SYN a_number = 5;
-- define an instance to be GRANTed to another process.

<> PROCESS_TYPE = 16 <>
<> PROCESS_TYPE = a_number <>

p1:
PROCESS (a INT, b LONG LOC);
  DCL rudi INSTANCE;
  DCL bob INT;
  DCL i INT, b1 BOOL;
  DCL chuck CHAR;
  DCL fred INSTANCE;

  rudi := GEN_INST (p2, a + 10);
  chprintf ("copy_number (rudi): %d^J", LONG (copy_number (rudi)));
  chprintf ("proc_type (rudi): %d^J", LONG (proc_type (rudi)));

  rudi := instance [ a + 5, a ];
  chprintf ("copy_number (rudi): %d^J", LONG (copy_number (rudi)));
  chprintf ("proc_type (rudi): %d^J", LONG (proc_type (rudi)));

  bob := GEN_PTYPE (p2);
  chprintf ("gen_ptype (p2): %d^J", bob);
  chprintf ("gen_code (p1): %d^J", GEN_CODE (p1));

-- try a signal as argument to a function
--  start_signal_timeout (10, done (), 5);

/* receive a signal */
for_ever:
  DO FOR EVER;
    RECEIVE CASE SET fred;
      (s1 IN i,b1):
         chprintf ("received s1:i = %d^J", LONG(i));
         chprintf ("received s1:b = %d^J", LONG(b1));
      (s2 IN i,b1):
      (s3):
         chprintf ("received s3:^J", 0);
      (s9 IN bob, i, chuck):
         chprintf ("received s9:bob = %d^J", LONG(bob));
         chprintf ("received s9:i = %d^J", LONG(i));
         chprintf ("received s9:chuck = '%c'^J", LONG(chuck));
      (done):
         EXIT for_ever;
      ELSE
         chprintf ("receive ELSE^J", 0);
    ESAC;
  OD;
END p1;
GRANT p1;

START p1 (-1, 28, long(ch)) SET ins;
--ins := START p1 (-1, 29, long(ch));
--START p1 (5, 33, ch) SET ins;

-- send a signal to the started process
--SEND s1 (10,TRUE) WITH 7 TO ins PRIORITY 5;
--SEND s1 (10,TRUE) WITH byte(7) TO ins PRIORITY 5;
--SEND s1 (10,TRUE) TO ins PRIORITY 5;
--SEND s1 (10,TRUE) WITH GEN_INST(p2, 10) TO ins PRIORITY 5;

/* send signals to created process */
xyz := 10;
SEND s1 (xyz, TRUE) TO ins;
SEND s2 (xyz + 10, FALSE) TO ins;
SEND s3 TO ins;
SEND s4 TO ins;
xyz := 98;
SEND s9 (9, xyz + 1, '9') TO ins;

/* this has to be the last signal.
   It breaks the receive case loop */
SEND done TO ins;
END start_;
