/* CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */
struct_: MODULE

SYNMODE is_dataarray = ARRAY (0:10) UBYTE;
SYNMODE is_desc = STRUCT (codeptr REF ULONG,
		   len     ULONG,
		   dataptr REF is_dataarray);
SYNMODE ref_desc = REF is_desc;

DCL first_var LONG := 0;

DCL i LONG;
DCL code ULONG := 4321;

DCL dataarray is_dataarray INIT := [ 10, 9, 8, 7, 6,
				      5, 4, 3, 2, 1, 0 ]; 

DCL desc is_desc INIT := [ ADDR (code), 1234, ADDR (dataarray) ];

DCL p ref_desc := ADDR (desc);
DCL addr_diff LONG;

WRITETEXT (STDOUT, "code = %C%/", code);

DO FOR i := LOWER (dataarray) TO UPPER (dataarray);
  WRITETEXT (STDOUT, "dataarray(%C) = %C%/", i, dataarray(i));
OD;
addr_diff := LONG (p) - LONG (->first_var);
WRITETEXT (STDOUT, "p = H'%H%/", addr_diff);

addr_diff := LONG(desc.codeptr) - LONG(->first_var);
WRITETEXT (STDOUT, "desc.codeptr = H'%H%/", addr_diff);
WRITETEXT (STDOUT, "desc.len     = %C%/", desc.len);
addr_diff := LONG(desc.dataptr) - LONG(->first_var);
WRITETEXT (STDOUT, "desc.dataptr = H'%H%/", addr_diff);
addr_diff := LONG (ADDR(code)) - LONG(->first_var);
WRITETEXT (STDOUT, "ADDR(code) = H'%H%/", addr_diff);
addr_diff := LONG (ADDR(dataarray)) - LONG(->first_var);
WRITETEXT (STDOUT, "ADDR(dataarray) = H'%H%/", addr_diff);
addr_diff := LONG(p->.codeptr) - LONG(->first_var);
WRITETEXT (STDOUT, "p->.codeptr = H'%H%/", addr_diff);
WRITETEXT (STDOUT, "p->.len     = %C%/", p->.len);
addr_diff := LONG(p->.dataptr) - LONG(->first_var);
WRITETEXT (STDOUT, "p->.dataptr = H'%H%/", addr_diff);

WRITETEXT (STDOUT, "p->.codeptr-> = %C%/", p->.codeptr->);
WRITETEXT (STDOUT, "p->.dataptr->(4) = %C%/", p->.dataptr->(4));
END struct_;
