
stud: MODULE

NEWMODE suits = SET (club, diamond, heart, spade);
NEWMODE ranks = SET (w2, w3, w4, w5, w6, w7, w8, w9,
                      w10, knave, queen, king, ace);
NEWMODE pcrd = STRUCT (suit suits, rank ranks);
NEWMODE cardpos = RANGE(1 : 52);

DCL deck ARRAY (cardpos) pcrd,
    s suits, r ranks, i INT;

rand: PROC () RETURNS (INT);
  DCL next ULONG STATIC INIT := 4711;
  next := next * 1103515245 + 12345;
  return next/65536 MOD 32768;
END rand;

randpos: PROC() RETURNS (cardpos);
  RETURN cardpos( rand() MOD 
                  INT( UPPER(cardpos) - LOWER(cardpos) ) 
                  + INT( LOWER(cardpos) ) );
END randpos;

swap: PROC (i, j cardpos);
  DCL c pcrd := deck(i);
  deck(i) := deck(j);
  deck(j) := c;
END swap;


cardcode: PROC ( c pcrd ) RETURNS (CHAR(2));
  SYN sc CHAR(4) = "CDHS";
  SYN rc CHAR(13) = "23456789TJQKA";
  RETURN sc(NUM(c.suit)) // rc(NUM(c.rank));
END cardcode;

draw_hand: PROC ();
  DO FOR i := 1 TO 5;
    WRITETEXT( stdout, "%C ", cardcode(deck(randpos())) );
  OD;
  WRITETEXT( stdout, "%/" );
END draw_hand;

i:= 0;
DO FOR s IN suits;
  DO FOR r IN ranks;
    i +:= 1;
    deck(cardpos(i)).suit := s;
    deck(cardpos(i)).rank := r;
 OD;
OD;

swap( 1, 10);
swap( 2, 20);
swap( 3, 30);
swap( 4, 40);
swap( 5, 50);

draw_hand();

END stud;
