sumfact: MODULE

-- There are some integer numbers with the property that the sum of the
-- factorials of the decimal digits is equal to the number itself, e.g.
--      2 = 2! = 1*2                                              
--      145 = 1! + 4! + 5! = 1 + 1*2*3*4 + 1*2*3*4*5

fact: PROC( n UINT IN ) RETURNS (UINT) RECURSIVE;
  IF n <= 1 THEN RETURN 1; ELSE RETURN fact(n-1)*n; FI;
END fact;

test: PROC( n UINT IN ) RETURNS (BOOL);
DCL h UINT := n;
DCL sum UINT := 0;
  h := n;
  sum := 0;
  DO WHILE h > 0;
    sum +:= fact(h MOD 10);
    h /:= 10;
  OD;
  RESULT n = sum;
END test;

IF test( 2 ) THEN WRITETEXT( stdout, "2 is ok%/" ); FI;
IF test( 145 ) THEN WRITETEXT( stdout, "145 is ok%/" ); FI;
IF test( 12345 ) THEN WRITETEXT( stdout, "12345 is NOT ok%/" ); FI;
IF test( 40585 ) THEN WRITETEXT( stdout, "40585 is ok%/" ); FI;

END sumfact;
