uni: MODULE

-- UNIQUE modifies a dynamic character string (mode: CHAR (max__len) VARYING).
-- All substrings consisting of the same char value are to be replaced by a 
-- single character (e.g. AABCCDDDE... is to become ABCDE...).

SYN max_len INT = 127;
SYNMODE m_strg = CHARS(max_len) VARYING;

DCL s m_strg;

unique:
PROC (a m_strg LOC);
   DCL in_pos, out_pos INT (0 : max_len-1);
   /* first char is unique */
   out_pos:= 0;
   /* if neighbours differ, take right one */
   DO FOR in_pos:= 1 TO LENGTH(a)-1;
      IF a(in_pos-1) /= a(in_pos) THEN
         out_pos +:= 1;
         a(out_pos):= a(in_pos);
      FI;
   OD;
   /* fill up with spaces */
   DO FOR out_pos:= out_pos+1 TO LENGTH(a)-1;
      a(out_pos):= ' ';
   OD;
END unique;

s := "AAABCCCDDDDEEEEEFGGGGGGGG";

WRITETEXT( stdout, s );
WRITETEXT( stdout, "%/" );

unique( s );

WRITETEXT( stdout, s );
WRITETEXT( stdout, "%/" );

END uni;
