/* CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */
wrtext: MODULE

<> USE_SEIZE_FILE "chillrt0.grt" <>
SEIZE chill_argc, chill_argv;

NEWMODE hugo = STRUCT (i INT, b BOOL);
DCL hugovar ARRAY (1:2) hugo;

DCL i INT := 4;
DCL outstr CHAR (200) VARYING;
--                     12345678901234567890123
DCL fstr CHAR (23) := "Hugo was  c times here^J";
SYN fstrs CHAR (23) = "Otto was %c times here^J";
DCL fstr1 CHAR (100) VARYING := "Varying Hugo was %c times here^J";
SYN fstr1s CHAR (100) VARYING = "Varying Otto was  c times here^J";

NEWMODE astruct = STRUCT (i INT,
                         s CHAR(23));
DCL s astruct := [ 10, "S.s. was %c times here^J"];
DCL s1 astruct := [ 10, "S.-> was %c times here^J"];
DCL rs REF astruct := ->s1;

DCL as ARRAY(1:2) astruct :=
  [
    [ 10, "S(1) was %c times here^J"],
    [ 10, "S(2) was  c times here^J"]
  ];

DCL l LONG;

NEWMODE ostruct = STRUCT (i INT,
                          s CHAR (200) VARYING);
DCL outstruct ostruct;
DCL refostruct REF ostruct := ->outstruct;
DCL ostructarr ARRAY (1:10) ostruct;

DCL bb BYTE := -10;
DCL ubb UBYTE := 254;
DCL ii INT := -22222;
DCL uii UINT := 44444;
DCL ll LONG := -99999;
DCL ull ULONG := 125358;
DCL rbb RANGE(1:10) := 9;

DCL c char := 'A';
DCL cindex INT;
DCL cs STRUCT (a, b, c, d CHAR) := [ 'A', 'B', 'c', 'd' ];
DCL ca ARRAY (5:10) CHAR;
DCL cc CHAR := '1';
DCL crange CHAR('A':'Z') := 'R';

DCL boo BOOL := TRUE;

DCL cstrvary CHAR (100) VARYING := "Hugo ist da";
DCL c10str CHAR(10) := "0123456789";
DCL cup INT;

DCL ins INSTANCE;

NEWMODE setmode = SET (moser, wilfried, niki, koenig, werner, king, klaus, reichl);
NEWMODE setmoderange = setmode(niki:king);
NEWMODE setmoderangerange = setmoderange(koenig:werner);
NEWMODE setrange = RANGE(werner:reichl);

DCL vsetmode setmode := moser;
DCL vsetmoderange setmoderange := king;
DCL vsetmoderangerange setmoderangerange := werner;
DCL vsetrange setrange := reichl;
DCL vset SET (hugo1, otto) := otto;

SIGNAL sig = (LONG);

SYN bssyn BIT(24) = B'111100001111000011110000';
SYN bslongsyn BIT(35) = B'00110011001100110011001100110011001';
DCL bsvar BIT(9) := B'101010101';

NEWMODE m_psbool = POWERSET BOOL;
DCL psbool m_psbool := [ FALSE, TRUE ];
NEWMODE m_pschar = POWERSET CHAR;
DCL pschar m_pschar := [ C'10', 'A', 'a' ];
NEWMODE m_psint = POWERSET INT(-100:100);
DCL psint  m_psint := [ -100, 0, 100 ];
NEWMODE m_psset = POWERSET setmode;
DCL psset m_psset := [ moser, reichl ];


dummyp: PROCESS ();
   DCL sender INSTANCE;
   DCL l LONG;

loop:
   RECEIVE CASE SET sender;
      (sig IN l):
         WRITETEXT (stdout, "%c: sig(%c) received from %c%/", this, l, sender);
	 IF l /= 10 THEN
	    SEND sig (l + 1) TO this;
	    goto loop;
         FI;
      ELSE ;
   ESAC;
END dummyp;

retbool: PROC (i INT) RETURNS (BOOL);
   IF i = 1 THEN
      RETURN TRUE;
   ELSE
      RETURN FALSE;
   FI;
END retbool;

check_ref_types: PROC (ins INSTANCE LOC, c10str CHAR(10) INOUT);
   WRITETEXT (stdout, "%c started%/", ins);
   WRITETEXT (stdout, "A char(%c) string = ""%c""%/", SIZE (c10str), c10str);
END check_ref_types;

do_enum_in_proc: PROC ();
   NEWMODE local_set = SET (loc_hugo = 10, loc_otto= 15, loc_rudi= 23);
   NEWMODE oldlocal_set = SET (a1, a2, a3, a4, a5);
   DCL locset local_set := loc_rudi;
   DCL oldlocset oldlocal_set := a3;

   next_level: PROC ();
      DCL locset SET (loc_hugo = 101, loc_otto= 151, loc_rudi= 231) := loc_rudi;
      DCL oldlocset SET (a1, a2, a3, a4, a5) := a3;

      next_levelp: PROC ();
         NEWMODE local_set = SET (loc_hugo = 201, loc_otto= 351, loc_rudi= 431);
         NEWMODE oldlocal_set = SET (a1, a2, a3, a4, a5);
         DCL locset local_set := loc_otto;
         DCL oldlocset oldlocal_set := a3;

         WRITETEXT (stdout, "%/*** Checking Enum's in a function level 3 ***%/");
         WRITETEXT (stdout, "locset = %c%/", locset);
         WRITETEXT (stdout, "oldlocset = %c%/", oldlocset);
      END next_levelp;

      WRITETEXT (stdout, "%/*** Checking Enum's in a function level 2 ***%/");
      WRITETEXT (stdout, "locset = %c%/", locset);
      WRITETEXT (stdout, "oldlocset = %c%/", oldlocset);
      next_levelp ();
   END next_level;

   WRITETEXT (stdout, "%/*** Checking Enum's in a function ***%/");
   WRITETEXT (stdout, "vsetmode = %c, SUCC(wilfried) = %c%/", vsetmode, SUCC(wilfried));
   WRITETEXT (stdout, "vsetmoderange = %c%/", vsetmoderange);
   WRITETEXT (stdout, "vsetmoderangerange = %c%/", vsetmoderangerange);
   WRITETEXT (stdout, "locset = %c%/", locset);
   WRITETEXT (stdout, "oldlocset = %c%/", oldlocset);
   next_level ();
END do_enum_in_proc;

WRITETEXT (stdout, "%/*** Checking Real's ***%/");
WRITETEXT (stdout, "1.3 = %R%/", 1.3);
WRITETEXT (stdout, "10.5e33 = %F%/", 10.5e33);

#if 0
WRITETEXT (stdout, "%/*** Checking Powerset's ***%/");
WRITETEXT (stdout, "psbool = %c%/", psbool);
WRITETEXT (stdout, "pschar = %c%/", pschar);
WRITETEXT (stdout, "psint = %c%/", psint);
WRITETEXT (stdout, "psset = %c%/", psset);
WRITETEXT (stdout, "empty powerset = %c%/", m_psbool[]);
WRITETEXT (stdout, "m_psbool[TRUE] = %c%/", m_psbool[TRUE]);
WRITETEXT (stdout, "m_pschar['0':'9'] = %c%/", m_pschar['0':'9']);
WRITETEXT (stdout, "m_psint[-99:-97, 50:55] = %c%/", m_psint[-99:-97, 50:55]);
WRITETEXT (stdout, "m_psset[koenig:klaus] = %c%/", m_psset[koenig:klaus]);
#endif

WRITETEXT (stdout, "%/*** Checking BitString's ***%/");
WRITETEXT (stdout, "bssyn = %c, bsvar = %c, bslongsyn = %c%/", bssyn, bsvar, bslongsyn);
WRITETEXT (stdout, "bssyn(2 up 6) = %c, bsvar(1:5) = %c%/", bssyn (2 UP 6), bsvar(1:5));

WRITETEXT (stdout, "%/*** Checking Enum's ***%/");
WRITETEXT (stdout, "vsetmode = %c, SUCC(wilfried) = %c%/", vsetmode, SUCC(wilfried));
WRITETEXT (stdout, "vsetmoderange = %c%/", vsetmoderange);
WRITETEXT (stdout, "vsetmoderangerange = %c%/", vsetmoderangerange);
WRITETEXT (stdout, "v SET (hugo1, otto) = %c%/", vset);
do_enum_in_proc ();

WRITETEXT (stdout, "%/*** Checking Pointers ***%/");
WRITETEXT (stdout, "refostruct = ADDR(outstruct)? %c%/",
	 refostruct = ADDR(outstruct));
WRITETEXT (stdout, "ADDR(refostruct) = refostruct? %c%/",
	 ADDR (refostruct) = PTR (refostruct));

START dummyp (-1) SET ins;
WRITETEXT (stdout, "%/*** Checking Instance ***%/");
WRITETEXT (stdout, "%c started%/", ins);

WRITETEXT (stdout, "%/*** Checking Character Strings ***%/");
WRITETEXT (stdout, "A varying charstr = ""%c""%/", cstrvary);
WRITETEXT (stdout, "A char(%c) string = ""%c""%/", SIZE (c10str), c10str);
WRITETEXT (stdout, "A char(3:5) string slice = ""%c""%/", c10str(3:5));
cindex := 3;
WRITETEXT (stdout, "A char(%c:5) string slice = ""%c""%/", cindex, c10str(cindex:5));
cup := 5;
WRITETEXT (stdout, "A char(%c:%c) string slice = ""%c""%/", cindex, cup, c10str(cindex:cup));
WRITETEXT (stdout, "A char(%c UP %c) string slice = ""%c""%/", cindex, cup, c10str(cindex UP cup));
WRITETEXT (stdout, "A char(%c:%c) varying string slice = ""%c""%/", cindex, cup, cstrvary(cindex:cup));
WRITETEXT (stdout, "A char(%c UP %c) varying string slice = ""%c""%/", cindex, cup,
	   cstrvary(cindex UP cup));

WRITETEXT (stdout, "%/*** Checking Booleans ***%/");
WRITETEXT (stdout, "boo = %c%/", boo);
DO FOR cindex := 1 TO 2;
   WRITETEXT (stdout, "retbool(%c) = %c ", cindex, retbool(cindex));
OD;
WRITETEXT (stdout, "%/");

WRITETEXT (stdout, "%/*** Checking Characters ***%/");
WRITETEXT (stdout, "c should be 'A'  and is '%c'%/", c);
refostruct->.s := "Moser Wilfried";
WRITETEXT (stdout, "refostruct->.s(0:%c) =", LENGTH (refostruct->.s) - 1);
DO FOR cindex := 0 TO LENGTH (refostruct->.s) - 1;
   WRITETEXT (stdout, " '%c'", refostruct->.s(cindex));
OD;
WRITETEXT (stdout, "%/");
WRITETEXT (stdout, "cs.a = '%c', cs.b = '%c', cs.c = '%c', cs.d = '%c'%/",
	   cs.a, cs.b, cs.c, cs.d);
DO FOR c IN ca;
   c := cc;
   cc := SUCC (cc);
OD;
DO FOR cindex := LOWER (ca) TO UPPER (ca);
   WRITETEXT (stdout, "ca(%c) = '%c'", cindex, ca(cindex));
   IF cindex /= UPPER (ca) THEN
      WRITETEXT (stdout, ", ");
   FI;
OD;
WRITETEXT (stdout, "%/");
c := c'00';
WRITETEXT (stdout, "c should be a null-char, is %c and a FF is %c%/", c, c'ff');
WRITETEXT (stdout, "Now a char-range ('A':'Z') is %c%/", crange);

WRITETEXT (stdout, "%/*** Checking Integers ***%/");
WRITETEXT (stdout, "%c %c %c %c %c %c %c %c%/", 1234, bb, ubb, ii, uii, ll, ull, rbb);

WRITETEXT (stdout, "%/*** Checking writestring ***%/");
WRITETEXT (outstr, as(1).s, 5678);
WRITETEXT (stdout, outstr);
WRITETEXT (outstruct.s, "Peter was %c times here^J", 1234);
WRITETEXT (stdout, outstruct.s);
WRITETEXT (refostruct->.s, rs->.s, 1234);
WRITETEXT (stdout, refostruct->.s);
WRITETEXT (outstr, s.s, 1234);
WRITETEXT (stdout, outstr);
WRITETEXT (outstr, fstr1, 1234);
WRITETEXT (stdout, outstr);
WRITETEXT (outstr, fstrs, 1234);
WRITETEXT (stdout, outstr);

WRITETEXT (stdout, "%/*** Checking reference types ***%/");
check_ref_types (ins, c10str);

WRITETEXT (stdout,"%/** Runstring**%/");
DO FOR l := 0 TO (chill_argc - 1);
   IF l = 0 THEN
      WRITETEXT (stdout, "./wrtext.exe");
   ELSE
      WRITETEXT (stdout, chill_argv->(l)->);
   FI;
   WRITETEXT (stdout, " ");
OD;
WRITETEXT (stdout, "%/%/*** Activate a process ***%/");

SEND sig(1) TO ins;

END wrtext;
