/* CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */
buffer_: MODULE

  SYN s_bool BOOL = TRUE;

  NEWMODE fred = BUFFER (23) FLOAT;
  NEWMODE bmode = BUFFER (30) STRUCT (mini, maxi INT);
--  NEWMODE bmode = BUFFER (30) STRUCT (mini INT, maxi BUFFER);
  NEWMODE fred1 = BUFFER (-2) INT;

  <> BUFFER_CODE = 10 <>
  DCL b1 BUFFER INT,
      b2 BUFFER(1) BOOL,
      b3 BUFFER CHAR;
  DCL b4 BUFFER (SIZE (INT)) INT;
  DCL afred fred;
  DCL bob BUFFER (3) INT; -- FIXME: sigabort := 12;
  DCL i, ii INT, ins INSTANCE,
      b BOOL, c CHAR;

  SIGNAL s1;

  afred := 3.1415;

--
-- some send buffer actions
--
  SEND b1 (10, 10);
  SEND b1 (TRUE);
  SEND rudi (20);
--  SEND fred (45); FIXME: sigsegv
  SEND b1 (10) WITH 3;
  SEND b1 (20) TO ins;
  SEND b1 (30) PRIORITY TRUE;
  SEND b1 (30) PRIORITY ii;

-- check signal and buffer mixed up  
  RECEIVE CASE SET i;
    (b3 IN c):	SEND b3 (c);
    (s1):       SEND b3 (c);
    ELSE	STOP; 
  ESAC;

-- check signal and buffer mixed up  
  RECEIVE CASE SET i;
    (s1):       SEND b3 (c);
    (b3 IN c):	SEND b3 (c);
    (s1):       SEND b3 (c);
    (b3 IN c):	SEND b3 (c);
    ELSE	STOP; 
  ESAC;

-- check buffer with no defining occurence
  RECEIVE CASE
    (b3):       SEND b3 (c);
  ESAC;

-- somthing undefined
  RECEIVE CASE
    (b3 IN undef1):     SEND b3 (c);
    (undef2 IN c):      SEND b3 (c);
    (undef3 IN undef4): SEND b3 (c);
  ESAC;

  RECEIVE CASE SET ins;
    (i IN ii):	SEND b1 (1) PRIORITY 6;
    (b2 IN b):	SEND b2 (FALSE);
    (b3 IN c):	SEND b3 (c);
    (b3 IN i):	SEND b3 (c);
    (b3 IN s_bool): 	SEND b3 (c);
    ELSE	STOP; 
  ESAC;


-- syntax error
--  RECEIVE CASE SET ins;
--  ESAC;

-- syntax error
--  RECEIVE CASE SET ins;
--    ELSE	STOP;
--  ESAC;

END buffer_;
