/* CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */
event_: MODULE

  SYN s_int LONG = 20;
  SYN s_bool BOOL = TRUE;

  <> EVENT_CODE = 11 <>
  NEWMODE fred = EVENT (23); 			-- valid
  NEWMODE bmode = EVENT (30);			-- valid
  NEWMODE fred1 = EVENT (-2);			-- error: not positive
  NEWMODE evchar = EVENT ('a');			-- error: not integer
  NEWMODE evbool = EVENT (TRUE);		-- error: not integer
  NEWMODE evexpr = EVENT (5 + 10);		-- valid
  NEWMODE evsynint = EVENT (s_int);		-- valid
  NEWMODE evsynbool = EVENT (s_bool);		-- error: not integer

  DCL b1 EVENT,
      b2 EVENT(1),
      b3 EVENT (count1);
  DCL count1, count2, count3 INT;
  DCL afred fred;
  DCL bob EVENT (3);
  DCL i, ii INT, ins INSTANCE,
      b BOOL, c CHAR;

  afred := 3.1415;

-- CONTINUE action
  CONTINUE b2;
  CONTINUE i;
  CONTINUE s_int;

-- DELAY action
  DELAY b1;
  DELAY b1 PRIORITY 10;
  DELAY i;
  DELAY b1 PRIORITY 'a';
  DELAY b1 PRIORITY hugo;
  DELAY otto;

-- DELAY CASE action
  DELAY CASE SET ins; PRIORITY 10;
    (i):	count1 := 1;
    (b2):	count2 := 2;
    (b3):	count3 := 3;
  ESAC;

  DELAY CASE SET ins; PRIORITY TRUE;
    (b1):	count1 := 1;
    (b2):	count2 := 2;
    (b3):	count3 := 3;
  ESAC;

  DELAY CASE SET i;
    (b1):	count1 := 1;
    (b2):	count2 := 2;
    (b3):	count3 := 3;
  ESAC;

  DELAY CASE SET ins;
  ESAC;

END event_;
