/* CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

rngfail: MODULE

-- this module is supposed to check all possibilities for
-- raising a rangefail exception during compile time
-- It's a derivative of the execute/rangefail.ch runtime test.
-- Let's keep them parallel as much as possible.

-- global used variables and functions 
DCL what_test CHAR (100) VARYING;

success: PROC ();
   WRITETEXT (stdout, what_test // " PASSED%/");
END success;

failed: PROC ();
   WRITETEXT (stdout, what_test // " FAILED%/");
END failed;

-- test chapter 4.2.7 String slices
z200_4_2_7: PROC ();
   DCL fstr CHAR (5) := "Moser";
   DCL vstr CHAR (30) VARYING := "Wilfried";
   DCL i, j INT;
   DCL res CHAR(20);

   what_test := "4.2.7 String slices left element lower-bound:";
--   i := -1;
--   j := 5;
   res(i:j) := fstr(-1:5) ON (rangefail): success (); GOTO left_upper; END;
   failed ();
left_upper:
   what_test := "4.2.7 String slices left element upper-bound:";
--   i := 3;
--   j := 6;
   res(i:j) := fstr(3:6) ON (rangefail): success (); GOTO right_lower; END;
   failed ();
right_lower:
   what_test := "4.2.7 String slices right element lower-bound:";
--   i := 3;
--   j := -1;
   res(i:j) := fstr (3:-1) ON (rangefail): success (); GOTO right_upper; END;
   failed ();
right_upper:
   what_test := "4.2.7 String slices right element upper-bound:";
--   i := 3;
--   j := 7;
   res(i:j) := fstr (3:7) ON (rangefail): success (); GOTO start_and_size; END;
   failed ();
start_and_size:
   what_test := "4.2.7 String slices right element start and size:";
--   i := 5;
   res (i UP 10) := fstr(5 UP 10) ON (rangefail): success (); GOTO fred; END;
   failed ();

fred:
   what_test := "4.2.7 Varying String slices left element lower-bound:";
--   i := -1;
--   j := 5;
   res(i:j) := vstr(-1:5) ON (rangefail): success (); GOTO left_upper_v; END;
   failed ();
left_upper_v:
   what_test := "4.2.7 Varying String slices left element upper-bound:";
--   i := 3;
--   j := 6;
   res(i:j) := vstr(3:6) ON (rangefail): success (); GOTO right_lower_v; END;
   failed ();
right_lower_v:
   what_test := "4.2.7 Varying String slices right element lower-bound:";
--   i := 3;
--   j := -1;
   res(i:j) := vstr (3:-1) ON (rangefail): success (); GOTO right_upper_v; END;
   failed ();
right_upper_v:
   what_test := "4.2.7 Varying String slices right element upper-bound:";
--   i := 3;
--   j := 7;
--   res(i:j) := vstr (3:7) ON (rangefail): success (); GOTO start_and_size_v; END;
   failed ();
start_and_size_v:
   what_test := "4.2.7 Varying String slices right element start and size:";
--   i := 5;
   res (i UP 10) := fstr(5 UP 10) ON (rangefail): success (); GOTO end_varying; END;
   failed ();

end_varying:
  i := 2;
END z200_4_2_7;

z200_4_2_7 ();

END rngfail;
