/* CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

rngfail: MODULE

-- this module is supposed to check all possibilities for
-- raising a rangefail exception during compile time
-- It's a derivative of the execute/rangefail.ch runtime test.
-- Let's keep them parallel as much as possible.

-- global used variables and functions 
DCL what_test CHAR (100) VARYING;

success: PROC ();
   WRITETEXT (stdout, what_test // " PASSED%/");
END success;

failed: PROC ();
   WRITETEXT (stdout, what_test // " FAILED%/");
END failed;

-- test chapter 6.20.3 chill value builtins
z200_6_20_3: PROC ();
   DCL bl BYTE := LOWER(BYTE);
   DCL bu BYTE := UPPER(BYTE);
   DCL b BYTE;
   DCL il INT := LOWER(INT);
   DCL iu INT := UPPER (INT);
   DCL i INT;
   DCL ll LONG := LOWER(LONG);
   DCL lu LONG := UPPER(LONG);
   DCL l LONG;
   DCL ubl UBYTE := LOWER(UBYTE);
   DCL ubu UBYTE := UPPER(UBYTE);
   DCL ub UBYTE;
   DCL uil UINT := LOWER(UINT);
   DCL uiu UINT := UPPER(UINT);
   DCL ui UINT;
   DCL ull ULONG := LOWER(ULONG);
   DCL ulu ULONG := UPPER(ULONG);
   DCL ul ULONG;
   NEWMODE intrange = INT(10:200);
   DCL riu intrange := UPPER(intrange);
   DCL ril intrange := LOWER(intrange);
   DCL ri intrange;
   NEWMODE ps_mode = POWERSET intrange;
   DCL ps ps_mode := [];
   NEWMODE anenum = SET (ax, bx, cx);
   DCL enumu anenum := UPPER (anenum);
   DCL enuml anenum := LOWER (anenum);
   DCL enum anenum;
   NEWMODE charrange = CHAR('A':'Z');
   DCL cru charrange := UPPER (charrange);
   DCL crl charrange := LOWER (charrange);
   DCL cr charrange;
   DCL bou BOOL := UPPER(BOOL);
   DCL bol BOOL := LOWER(BOOL);
   DCL bo BOOL;

   what_test := "6.20.3 PRED (LOWER (BYTE)):";
   b := PRED (LOWER(BYTE)) ON (overflow): success(); GOTO succ_upper_byte; END;
   failed ();
succ_upper_byte:
   what_test := "6.20.3 SUCC (UPPER (BYTE)):";
   b := SUCC (UPPER(BYTE)) ON (overflow): success (); GOTO pred_lower_int; END;
   failed ();
pred_lower_int:
   what_test := "6.20.3 PRED (LOWER (INT)):";
   i := PRED (LOWER(INT)) ON (overflow): success(); GOTO succ_upper_int; END;
   failed ();
succ_upper_int:
   what_test := "6.20.3 SUCC (UPPER (INT)):";
   i := SUCC (UPPER(INT)) ON (overflow): success (); GOTO pred_lower_long; END;
   failed ();
pred_lower_long:
   what_test := "6.20.3 PRED (LOWER (LONG)):";
   l := PRED (LOWER(LONG)) ON (overflow): success(); GOTO succ_upper_long; END;
   failed ();
succ_upper_long:
   what_test := "6.20.3 SUCC (UPPER (LONG)):";
   l := SUCC (UPPER(LONG)) ON (overflow): success (); GOTO pred_lower_ubyte; END;
   failed ();
pred_lower_ubyte:
   what_test := "6.20.3 PRED (LOWER (UBYTE)):";
   ub := PRED (LOWER(UBYTE)) ON (overflow): success(); GOTO succ_upper_ubyte; END;
   failed ();
succ_upper_ubyte:
   what_test := "6.20.3 SUCC (UPPER (UBYTE)):";
   ub := SUCC (UPPER(UBYTE)) ON (overflow): success (); GOTO pred_lower_uint; END;
   failed ();
pred_lower_uint:
   what_test := "6.20.3 PRED (LOWER (UINT)):";
   ui := PRED (LOWER(UINT)) ON (overflow): success(); GOTO succ_upper_uint; END;
   failed ();
succ_upper_uint:
   what_test := "6.20.3 SUCC (UPPER (UINT)):";
   ui := SUCC (UPPER(UINT)) ON (overflow): success (); GOTO pred_lower_ulong; END;
   failed ();
pred_lower_ulong:
   what_test := "6.20.3 PRED (LOWER (ULONG)):";
   ul := PRED (LOWER(ULONG)) ON (overflow): success(); GOTO succ_upper_ulong; END;
   failed ();
succ_upper_ulong:
   what_test := "6.20.3 SUCC (UPPER (ULONG)):";
   ul := SUCC (UPPER(ULONG)) ON (overflow): success (); GOTO pred_lower_intrange; END;
   failed ();
pred_lower_intrange:
   what_test := "6.20.3 PRED (LOWER (INT (10:200))):";
   ri := PRED (LOWER(intrange)) ON (overflow): success (); GOTO succ_upper_intrange; END;
   failed ();
succ_upper_intrange:
   what_test := "6.20.3 SUCC (UPPER (INT (10:200))):";
   ri := SUCC (UPPER(intrange)) ON (overflow): success (); GOTO pred_lower_enum; END;
   failed ();
pred_lower_enum:
   what_test := "6.20.3 PRED (LOWER (SET (ax, bx, cx))):";
   enum := PRED (LOWER(anenum)) ON (overflow): success (); GOTO succ_upper_enum; END;
   failed ();
succ_upper_enum:
   what_test := "6.20.3 SUCC (UPPER (SET (ax, bx, cx))):";
   enum := SUCC (UPPER(anenum)) ON (overflow): success (); GOTO pred_lower_char_range; END;
   failed ();
pred_lower_char_range:
   what_test := "6.20.3 PRED (LOWER (CHAR ('A':'Z'))):";
   cr := PRED (LOWER (charrange)) ON (overflow): success (); GOTO succ_upper_char_range; END;
   failed ();
succ_upper_char_range:
   what_test := "6.20.3 SUCC (UPPER (CHAR ('A':'Z'))):";
   cr := SUCC (UPPER (charrange)) ON (overflow): success (); GOTO pred_lower_bool; END;
   failed ();
pred_lower_bool:
   what_test := "6.20.3 PRED (LOWER (BOOL)):";
   bo := PRED (LOWER(BOOL)) ON (overflow): success (); GOTO succ_upper_bool; END;
   failed ();
succ_upper_bool:
   what_test := "6.20.3 SUCC (UPPER (BOOL)):";
   bo := SUCC (UPPER(BOOL)) ON (overflow): success (); GOTO min_empty_powerset; END;
   failed ();
min_empty_powerset:
   what_test := "6.20.3 MIN on empty powerset:";
   ri := MIN (ps_mode[]) ON (empty): success (); GOTO max_empty_powerset; END;
   failed ();
max_empty_powerset:
   what_test := "6.20.3 MAX on empty powerset:";
   ri := MAX (ps_mode[]) ON (empty): success (); RETURN; END;
   failed ();

END z200_6_20_3;

z200_6_20_3 ();

END rngfail;
