/* CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

rngfail: MODULE

-- this module is supposed to check all possibilities for
-- raising a rangefail exception during compile time
-- It's a derivative of the execute/rangefail.ch runtime test.
-- Let's keep them parallel as much as possible.

-- global used variables and functions 
DCL what_test CHAR (100) VARYING;

success: PROC ();
   WRITETEXT (stdout, what_test // " PASSED%/");
END success;

failed: PROC ();
   WRITETEXT (stdout, what_test // " FAILED%/");
END failed;

-- test some assignments of ranges
range_assgn: PROC ();
   DCL i INT := 100;
   DCL ir INT(0:10);
   DCL c CHAR := 'a';
   DCL cr CHAR('A':'Z');
   DCL boo BOOL := FALSE;
   DCL boor BOOL(TRUE:TRUE);
   SYNMODE aset = SET (aa, bb, xx, yy, zz);
   SYNMODE setrange = aset(xx:yy);
   DCL s aset := aa;
   DCL sr setrange;

   what_test := "INT(0:10) := INT:";
   ir := 100 ON (rangefail): success (); GOTO char_range; END;
   failed ();
char_range:
   what_test := "CHAR('A':'Z') := CHAR:";
   cr := 'a' ON (rangefail): success (); GOTO bool_range; END;
   failed ();
bool_range:
   what_test := "BOOL(TRUE:TRUE) := BOOL:";
   boor := FALSE ON (rangefail): success (); GOTO set_range; END;
   failed ();
set_range:
   what_test := "setrange(xx:yy) := set(aa, bb, xx, yy, zz):";
   sr := aa ON (rangefail): success (); RETURN; END;
   failed ();
END range_assgn;

range_assgn ();

END rngfail;
