/* CHILL compiler regression test file
 Copyright (C) 1992, 1993 Free Software Foundation, Inc.
 
 This file is part of GNU CC.

 GNU CC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 GNU CC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GNU CC; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

rngfail: MODULE

-- this module is supposed to check all possibilities for
-- raising a rangefail exception during compile time
-- It's a derivative of the execute/rangefail.ch runtime test.
-- Let's keep them parallel as much as possible.

-- global used variables and functions 
DCL what_test CHAR (100) VARYING;

success: PROC ();
   WRITETEXT (stdout, what_test // " PASSED%/");
END success;

failed: PROC ();
   WRITETEXT (stdout, what_test // " FAILED%/");
END failed;

-- test chapter 4.2.6 string elements
z200_4_2_6: PROC ();
   DCL fstr CHAR (5) := "Moser";
   DCL vstr CHAR (30) VARYING := "Wilfried";
   DCL i INT;
   DCL c CHAR;

   what_test := "4.2.6 String elements fixed-length lower-bound:";
--   i := -1;
   c := fstr(-1) ON (rangefail): success (); GOTO fixed_upper; END;
   failed ();
fixed_upper:
   what_test := "4.2.6 String elements fixed-length upper-bound:";
--   i := SIZE (fstr);
   c := fstr(SIZE (fstr)) ON (rangefail): success (); GOTO varying_lower; END;
   failed ();
varying_lower:
   what_test := "4.2.6 String elements varying-length lower-bound:";
--   i := -1;
   c := vstr(-1) ON (rangefail): success (); GOTO varying_upper; END;
   failed ();
varying_upper:
   what_test := "4.2.6 String elements varying-length upper-bound:";
--   i := length (vstr) + 1;
   c := vstr (length (vstr) + 1) ON (rangefail): success (); RETURN; END;
   failed ();
END z200_4_2_6;

z200_4_2_6 ();

END rngfail;
