#
# Package Jason's tcov output as a single line
# per function.  Print a totals line.
#
/^\*\*\*/	{ 
		  split ($2, a, "/"); 
		  file = a[10]; 
		  if (length (file) > maxfilelength)
		    maxfilelength = length (file);
		}

/^[^ 	]/	{
		  split ($1, a, ":");
		  funcname = a[1];
		  totfunc++;
		  if (length (funcname) > maxfunclength)
		    maxfunclength = length (funcname);
		}

/total lines$/	{
		  lines = $1; 
		  totlines += lines;
		}

/lines covered$/{
		  covered = $1;
		  totcovered += covered;
		}

/coverage$/	{
		  printf ("%-*s %-*s %5d %5d %03s\n",
			  maxfilelength, file, 
			  maxfunclength, funcname,
			  lines, covered, $1);
		}

END		{
		  printf ("%d functions, %02d%% av. coverage\n",
			  totfunc, (100 * totcovered) / totlines);
		}

