#! /bin/sh
# Prepare a tcov report on the CHILL compiler.
# For problems, see Jason Merrill.
# 

# To be run from inside devo directory
BASE=/tarkas/bill/devo
BIN=/cygint/s1/users/bin
cd $BASE
make clean

# Build the non-CHILL-specific objects with Sun's cc
make all-gcc all-chillrt CC=cc
cd gcc
rm ch-parse.o ch-actions.o ch-except.o ch-grant.o ch-lang.o ch-tree.o ch-lex.o
rm ch-decl.o ch-typeck.o ch-convert.o ch-expr.o ch-loop.o ch-tasking.o 
rm ch-inout.o ch-satisfy.o c-typeck.o c-aux-info.o c-common.o c-iterate.o
rm toplev.o

# Make the CHILL objects, with tcov counting enabled
make "CC=cc -a" CFLAGS= cc1chill

cd ..
$(BIN)/regression.sh

# Run emacs to digest the contents of the *.d files
emacs-19 -batch -q -l $(BIN)/tcov.el -f tcov tcov.out ch-actions.c \
	ch-except.c ch-grant.c ch-lang.c ch-tree.c ch-decl.c ch-typeck.c \
	ch-convert.c ch-expr.c ch-loop.c ch-tasking.c ch-inout.c ch-satisfy.c \
	c-typeck.c c-aux-info.c c-common.c c-iterate.c
#	ch-parse.y ch-lex.l
